package card_pay

//绑卡
func BindCard(keyArr, param map[string]string) (string, error) {
	//param = map[string]string{
	//	"version":          "2.0",
	//	"mchtOrderNo":      "123456",                           //流水号不能为空
	//	"memberId":         "562902003186055",                  //分账模式（splitModel）为“1-普通分账”的，该值一律传商户自编的编号。
	//	"transType":        "01",                               //值可填“01 快捷支付、02 代收”。		不填时默认 01 快捷支付
	//	"userName":         RsaEncrypts("黄加价"),                 //分账主体商户姓名
	//	"phoneNum":         RsaEncrypts("15217160421"),         //手机号码
	//	"bankCardNo":       RsaEncrypts("9558812345678912345"), //银行卡号
	//	"bankCardType":     "debit",                            //银行卡类型 debit：储蓄卡 credit：信用卡
	//	"certificatesType": "01",                               //证件类型 固定传 01-身份证
	//	"certificatesNo":   RsaEncrypts("440421199508298123"),  //证件号码
	//	"expired":          RsaEncrypts("1802"),                //有效日期 信用卡必填 yymm，例如 2018 年 2 月，		则为 1802		密文，加密方法参考“敏感信息加密”
	//	"cvn":              RsaEncrypts("123"),                 //CVN 码
	//	"isSendIssuer":     "true",                             //绑卡模式 分账模式（splitModel）为“1-普通分账”时选填：true：绑交易卡，需要短信确认。同时该交易卡拥有结算卡资格。false：绑结算卡，不需要短信确认
	//}
	return CardPaySend("api/txs/protocol/bindCard", keyArr, param)
}
func CheckBindCard(keyArr, param map[string]string) (string, error) {
	//param = map[string]string{
	//	"version":  "2.0",
	//	"smsNo":    "QY202306081339273143191", //绑卡流水号
	//	"memberId": "562902003186055",         //分账模式（splitModel）为“1-普通分账”的，该值一律传商户自编的编号。
	//	"smsCode":  "123456",                  //短息验证码
	//}
	return CardPaySend("api/txs/protocol/bindCardConfirm", keyArr, param)
}
func GetBindCard(keyArr, param map[string]string) (string, error) {
	//param = map[string]string{
	//	"version":  "2.0",
	//	"memberId": "562902003186055", //分账模式（splitModel）为“1-普通分账”的，该值一律传商户自编的编号。
	//}
	return CardPaySend("api/txs/protocol/queryProtocol", keyArr, param)
}
func UnBindCard(keyArr, param map[string]string) (string, error) {
	//param = map[string]string{
	//	"version":  "2.0",
	//	"protocol": "p202306087980109101214",
	//	"memberId": "562902003186055", //分账模式（splitModel）为“1-普通分账”的，该值一律传商户自编的编号。
	//}
	return CardPaySend("api/txs/protocol/unBindCard", keyArr, param)
}
func Pay(keyArr map[string]string, param map[string]interface{}) (string, error) {
	//memberId := "562932003186159"
	//ordId := "217021686896757585"
	//amount := "100"
	//param = map[string]interface{}{
	//	"version":              "2.0",
	//	"protocol":             "p202306161003031409342",
	//	"outTradeNo":           ordId,
	//	"transType":            "01",
	//	"isSendSmsCode":        "1",
	//	"payAmount":            amount,
	//	"payCurrency":          "CNY",
	//	"transactionStartTime": time.Now().Format("20060102150405"),
	//	"memberId":             memberId, //分账模式（splitModel）为“1-普通分账”的，该值一律传商户自编的编号。
	//	"notifyUrl":            "https://inapi.izhyin.cn/api/v1/swipe/order/notify/123456",
	//	"splitNotifyUrl":       "https://inapi.izhyin.cn/api/v1/swipe/order/split_notify/123456",
	//}
	//goodsList := []map[string]string{
	//	{
	//		"name":   "充值",
	//		"number": "1",
	//		"amount": amount,
	//	},
	//}
	//orderInfo := map[string]interface{}{
	//	"Id":           ordId,
	//	"businessType": "130003",
	//	"goodsList":    goodsList,
	//}
	//param["orderInfo"] = orderInfo
	//
	//param["needSplit"] = true
	//param["splitMain"] = param["memberId"]
	//param["splitModel"] = "5"
	//splitInfoList := []map[string]string{
	//	{
	//		"amount":              "2",
	//		"customerCode":        CustomerCode,
	//		"isProcedureCustomer": "3",
	//	},
	//	{
	//		"amount":              "98",
	//		"customerCode":        memberId,
	//		"isProcedureCustomer": "0",
	//	},
	//}
	//param["splitInfoList"] = splitInfoList

	return CardPaySendSecond("api/txs/protocol/protocolPayPre", keyArr, param)
}
func CheckPay(keyArr, param map[string]string) (string, error) {
	//param = map[string]string{
	//	"version":  "2.0",
	//	"protocol": "p202306084666779900235",
	//	"token":    "6d16c108f29340f7b30c9a2f055f88c9",
	//	"smsCode":  "123456",
	//}
	return CardPaySend("api/txs/protocol/protocolPayConfirm", keyArr, param)
}
func PaymentQuery(keyArr, param map[string]string) (string, error) {
	//param = map[string]string{
	//	"version":    "2.0",
	//	"outTradeNo": "1111111",
	//}
	return CardPaySend("api/txs/pay/PaymentQuery", keyArr, param)

	/***
	00 支付成功，订单结束 如果没有收到异步通知，请调用查询接口确认
	01 支付失败，订单结束 失败原因参考 returnCode 和 returnMsg 中的信息
	03 处理中 等待异步通知接口回调或者调用查询接口确认订单状态
	05 已撤销 被扫订单成功调用订单撤销（IF-Common-03）接口后，订单进入“已
	撤销“状态
	06 已关闭 主扫订单成功调用关单（IF-Common-04）接口后，订单进入已关闭
	状态
	*/
}

func SplitOrderResultQuery(keyArr, param map[string]string) (string, error) {
	//param = map[string]string{
	//	"version":    "2.0",
	//	"outTradeNo": "1111111",
	//}
	return CardPaySend("api/txs/pay/SplitOrderResultQuery", keyArr, param)

	/***
	00 分账成功 如果没有收到异步通知，请调用查询接口确认
	01 分账失败 失败原因参考 returnCode 和 returnMsg 中的信息
	03 处理中 等待异步通知接口回调或者调用查询接口确认订单状态
	04 预分帐成功 账户分账预分帐成功
	05 已撤销 分账已撤销
	51 待处理 待处理分账
	*/
}

func ApplyStore(keyArr, param map[string]string) (string, error) {
	//paperMap := map[string]string{
	//	"contactPerson": "黄加价",         //联系人姓名
	//	"contactPhone":  "15217160422", //联系人手机号码
	//	"shortName":     "测试",          //商户简称
	//	"merchantType":  "3",           //：个人(小微)；
	//
	//	"lawyerCertType":       "0",                  //证件类型
	//	"lawyerCertNo":         "440421199508298123", //证件号码
	//	"lawyerCertPhotoFront": "",                   //证件正面照
	//	"lawyerCertPhotoBack":  "",                   //证件背面照
	//	"certificateName":      "黄加价",                //证件人姓名
	//	"certificateFrom":      "",                   //证件效期(起始)yyyymmdd
	//	"certificateTo":        "",                   //证件效期(截止)：yyyymmdd，无限期填写“长期”
	//	"legalPersonPhone":     "15217160422",        //法人手机号码
	//	"settleTarget":         "1",                  //结算方式 1：自动提现； 2：手动提现
	//	"settleAccountType":    "2",                  //结算账户类型  1：对公账户 2：法人账户 3：授权对公 4：授权对私
	//	"settleAccountNo":      "6214830201234567",   //结算账户号
	//	"settleAccount":        "黄加价",                //结算账户名
	//	"openBank":             "中国银行",               //开户银行
	//}
	//paper := zhios_third_party_utils.SerializeStr(paperMap)
	//param = map[string]string{
	//	"version":      "2.0",
	//	"acqSpId":      CustomerCode,
	//	"merId":        "123",
	//	"backUrl":      "",
	//	"merchantName": "测试123",
	//	"paper":        paper,
	//	"acceptOrder":  "0",
	//}
	return CardPayApplySend("api/cust/SP/Merchant/apply", keyArr, param)
}
func ApplyStoreQuery(keyArr, param map[string]string) (string, error) {
	//paperMap := map[string]string{
	//	"contactPerson": "黄加价",         //联系人姓名
	//	"contactPhone":  "15217160422", //联系人手机号码
	//	"shortName":     "测试",          //商户简称
	//	"merchantType":  "3",           //：个人(小微)；
	//
	//	"lawyerCertType":       "0",                  //证件类型
	//	"lawyerCertNo":         "440421199508298123", //证件号码
	//	"lawyerCertPhotoFront": "",                   //证件正面照
	//	"lawyerCertPhotoBack":  "",                   //证件背面照
	//	"certificateName":      "黄加价",                //证件人姓名
	//	"certificateFrom":      "",                   //证件效期(起始)yyyymmdd
	//	"certificateTo":        "",                   //证件效期(截止)：yyyymmdd，无限期填写“长期”
	//	"legalPersonPhone":     "15217160422",        //法人手机号码
	//	"settleTarget":         "1",                  //结算方式 1：自动提现； 2：手动提现
	//	"settleAccountType":    "2",                  //结算账户类型  1：对公账户 2：法人账户 3：授权对公 4：授权对私
	//	"settleAccountNo":      "6214830201234567",   //结算账户号
	//	"settleAccount":        "黄加价",                //结算账户名
	//	"openBank":             "中国银行",               //开户银行
	//}
	//paper := zhios_third_party_utils.SerializeStr(paperMap)
	//param = map[string]string{
	//	"version":      "2.0",
	//	"acqSpId":      CustomerCode,
	//	"merId":        "123",
	//	"backUrl":      "",
	//	"merchantName": "测试123",
	//	"paper":        paper,
	//	"acceptOrder":  "0",
	//}
	return CardPayApplySend("api/cust/SP/Merchant/query", keyArr, param)
}

func AccountQuery(keyArr, param map[string]string) (string, error) {

	//param := map[string]string{
	//	"accountType":  "2",
	//	"customerCode": "562932003186159",
	//}
	return CardPaySend("api/acc/accountQuery", keyArr, param)
}
func WithdrawalForSubMerchant(keyArr, param map[string]string) (string, error) {

	//param := map[string]string{
	//	"version":    "3.0",
	//	"outTradeNo": "1233333444",
	//	"memberId":   "562658004035964",
	//	//"protocol":              "p202306201841814421887",
	//	"payAmount":             "98",
	//	"procedureCustomerCode": "",
	//	"payCurrency":           "CNY",
	//	"notifyUrl":             "http://inapi.izhyin.cn/api/v1/swipe/withdrawal/notify/123456",
	//}
	return CardPaySend("/api/txs/pay/WithdrawalForSubMerchant", keyArr, param)
}
func WithdrawalQueryForSubMerchant(keyArr, param map[string]string) (string, error) {

	//param := map[string]string{
	//	"version":    "3.0",
	//	"outTradeNo": "1233333444",
	//	"memberId":   "562658004035964",
	//	//"protocol":              "p202306201841814421887",
	//	"payAmount":             "98",
	//	"procedureCustomerCode": "",
	//	"payCurrency":           "CNY",
	//	"notifyUrl":             "http://inapi.izhyin.cn/api/v1/swipe/withdrawal/notify/123456",
	//}
	return CardPaySend("/api/txs/pay/WithdrawalQueryForSubMerchant", keyArr, param)
}
