package svc

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/db"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/db/model"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/db/offical"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/haodanku"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/jd"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/lib/cps_jd"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/md"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/pdd"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/taobao"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/tik_tok"
	zhios_third_party_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/utils"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/utils/cache"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/vip"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/zhimeng"
	"encoding/json"
	"errors"
	"fmt"
	"github.com/jinzhu/copier"
	"github.com/syyongx/php2go"
	"github.com/tidwall/gjson"
	"math/rand"
	"regexp"
	"strings"
	"time"
	"xorm.io/xorm"
)

// 转链主入口
func TurnChainFeatures(eg *xorm.Engine, officialEg, zhimengEg *xorm.Engine, tikTokBase map[string]string, user *model.User) (*md.ConvertedUrls, error) {
	pvd := tikTokBase["pvd"]
	dbName := tikTokBase["master_id"]
	goodsId := tikTokBase["gid"]
	var (
		//cfg  map[string]string
		err  error
		urls *md.ConvertedUrls
	)
	userProfile, _ := db.UserProfileFindByID(eg, user.Uid)
	if userProfile != nil {
		if pvd == md.PVD_TB || pvd == md.PVD_TM {
			//新的渠道id 存储
			relation := db.GetTaobaoUserRelationByUid(eg, userProfile.Uid)
			if relation != nil {
				userProfile.AccTaobaoShareId = relation.RelationId
				tikTokBase["union_id"] = zhios_third_party_utils.IntToStr(relation.UnionId)
			}
		}
		tikTokBase["acc_taobao_share_id"] = zhios_third_party_utils.Int64ToStr(userProfile.AccTaobaoShareId)
		if userProfile.AccJdCloudId == "" {
			userProfile.AccJdCloudId = userProfile.AccJdShareId
		}
		tikTokBase["acc_jd_share_id"] = userProfile.AccJdCloudId
		tikTokBase["acc_pdd_self_id"] = userProfile.AccPddSelfId
		tikTokBase["acc_vip_self_id"] = userProfile.AccVipShareId
	}
	tikTokBase["uid"] = zhios_third_party_utils.IntToStr(user.Uid)
	tikTokBase["gid"] = goodsId
	tikTokBase["master_id"] = dbName
	tikTokBase["provider"] = pvd
	switch pvd {
	case md.PVD_TIKTOK:
		if strings.Contains(goodsId, "cid") {
			ex := strings.Split(goodsId, "cid")
			goodsId = ex[0]
		}
		goodsId += "csjp"
		tikTokBase["gid"] = goodsId
		urls, err = TikTokTurnChain(eg, officialEg, zhimengEg, dbName, tikTokBase)
	case md.PVD_TB, md.PVD_TM:
		urls, err = TBOrTmTurnChain(eg, officialEg, zhimengEg, dbName, tikTokBase)
	case md.PVD_JD:
		urls, err = JDTurnChain(eg, dbName, tikTokBase)

	case md.PVD_PDD:
		urls, err = PDDTurnChain(eg, dbName, tikTokBase)
	case md.PVD_VIP:
		urls, err = VipTurnChain(eg, dbName, tikTokBase)
	default:
		return nil, errors.New("失败")
	}
	return urls, err
}
func TBOrTmTurnChain(eg *xorm.Engine, officialEg, zhimengEg *xorm.Engine, dbName string, args map[string]string) (*md.ConvertedUrls, error) {
	urls, err := ConvertUrl(eg, officialEg, zhimengEg, args)
	if err != nil {
		return nil, err
	}

	var couponUrl = ""
	if urls != nil {
		taobaoSdk, err := taobao.NewTaobaoSDK(eg, dbName, args["platform"], zhios_third_party_utils.StrToInt(args["acc_taobao_share_id"]), args["union_id"])
		if err != nil {
			fmt.Println("=======商品10", err)

			return nil, nil
		}
		bizSceneId := "2"
		itemInfo, err := taobaoSdk.ItemDetailById(args["gid"], bizSceneId)
		if err != nil {
			return nil, nil
		}
		//调用好单库
		hdkItemInfo, err := haodanku.HaodankuDetail(args["gid"])
		if err != nil {
			return nil, nil
		}
		if urls.ItemUrl == "" {
			urls.ItemUrl = urls.URL
		}
		if zhios_third_party_utils.StrToFloat64(itemInfo.CouponAmount) == 0 && zhios_third_party_utils.StrToFloat64(hdkItemInfo.CouponAmount) == 0 {
			urls.ShortenURL = urls.ItemUrl
			urls.URL = urls.ItemUrl
			urls.NoOpenAppURL = urls.ItemUrl
		}
		couponUrl = urls.ShortenURL
		//如果优惠券高 读取隐藏券
		if zhios_third_party_utils.StrToFloat64(hdkItemInfo.CouponAmount) > zhios_third_party_utils.StrToFloat64(itemInfo.CouponAmount) && zhios_third_party_utils.StrToFloat64(hdkItemInfo.CouponAmount) > 0 {
			couponUrl += "&activityId=" + hdkItemInfo.ActivityId
		}
		//分享或纯渠道要拼上渠道id
		if zhios_third_party_utils.StrToInt(args["acc_taobao_share_id"]) > 0 && strings.Contains(couponUrl, "&relationId=") == false {
			couponUrl = couponUrl + "&relationId=" + args["acc_taobao_share_id"]
		}
		if urls.NewPid != "" && strings.Contains(couponUrl, "&relationId=") == false {
			if args["platform"] == md.PLATFORM_WX_APPLET && zhios_third_party_utils.StrToInt(args["acc_taobao_share_id"]) == 0 {
				couponUrl = couponUrl + "&relationId=" + zhios_third_party_utils.Int64ToStr(urls.TbShareId)
			}
		}
		urls.ShortenURL = couponUrl
	}
	return urls, nil
}

// 京东转链
func JDTurnChain(eg *xorm.Engine, dbName string, args map[string]string) (*md.ConvertedUrls, error) {
	pid := args["acc_jd_share_id"]
	urls, err := cps_jd.JdUrl(eg, dbName, args["uid"], "3", db.SysCfgGetWithDb(eg, dbName, md.KEY_CFG_ZM_AK),
		db.SysCfgGetWithDb(eg, dbName, md.KEY_CFG_ZM_SK),
		args["gid"],
		pid,
		"",
		"",
		"")
	if err != nil {
		return nil, err
	}
	return urls, nil
}
func VipTurnChain(eg *xorm.Engine, dbName string, args map[string]string) (*md.ConvertedUrls, error) {
	// 初始化vip配置
	pid := args["acc_vip_share_id"]
	openId := pid
	pidType := "cloud"
	auth, _ := db.SysUnionByPVDByUse(eg, dbName, "vip")
	unionType := ""
	if auth != nil {
		if auth.AuthType == 2 {
			pid = zhimeng.GetWphPid(zhios_third_party_utils.StrToInt(args["uid"]), pidType, dbName)
			openId = pid
		}
		unionType = zhios_third_party_utils.IntToStr(auth.AuthType)
	}
	var urls *md.ConvertedUrls
	var err error
	if unionType == "2" {
		urls, err = zhimeng.OwnWphConvertUrl(auth,
			args["gid"],
			pid,
			"", "vendoapi", openId, "1")
	} else {
		urls, err = zhimeng.VipConvertUrl(
			db.SysCfgGetWithDb(eg, dbName, md.KEY_CFG_ZM_AK),
			db.SysCfgGetWithDb(eg, dbName, md.KEY_CFG_ZM_SK),
			args["gid"],
			pid,
			"", "vendoapi", openId, "1")
	}
	if err != nil {
		return nil, err
	}
	return urls, nil
}

// pdd转链
func PDDTurnChain(eg *xorm.Engine, dbName string, args map[string]string) (*md.ConvertedUrls, error) {
	pid := args["acc_pdd_self_id"]
	union, _ := db.SysUnionByPVDByUse(eg, dbName, "pdd")
	var urls *md.ConvertedUrls
	var err error
	miniApp := "0"
	isShares := "2"
	if union != nil && union.AuthType == 2 {
		pid = "own_" + dbName + "_" + args["uid"]
		urls, err = zhimeng.OwnPDDConvertUrl(union, args["gid"], pid, "", miniApp, "", isShares)
		if err != nil {
			return nil, err
		}
		return urls, nil
	}
	thirdZmAppKeyData, err := db.SysCfgGetOne(eg, "third_zm_app_key")
	if thirdZmAppKeyData == nil || err != nil {
		return urls, err
	}
	thirdZmAppSecretData, err := db.SysCfgGetOne(eg, "third_zm_app_secret")
	if thirdZmAppSecretData == nil || err != nil {
		return urls, err
	}

	masterPid := pid
	pddPidData, _ := pdd.NewZhiMengPDDSDK().
		SelectFunction("get_pid_list").
		WithArgs(map[string]interface{}{
			"appkey":     db.SysCfgGetWithDb(eg, dbName, md.KEY_CFG_ZM_AK),
			"secret_key": db.SysCfgGetWithDb(eg, dbName, md.KEY_CFG_ZM_SK),
			"pid":        masterPid},
		).Result()
	if pddPidData != nil {
		b, _ := json.Marshal(pddPidData.ToInterface())
		pddPid := gjson.GetBytes(b, "pdd_pid").String()
		if pddPid == "" {
			profile, _ := db.UserProfileFindByID(eg, 0)
			if profile != nil {
				masterPid = profile.AccPddSelfId
			}
		}
	} else {
		profile, _ := db.UserProfileFindByID(eg, 0)
		if profile != nil {
			masterPid = profile.AccPddSelfId
		}
	}
	urls, err = zhimeng.PDDConvertUrl(
		thirdZmAppKeyData.Val,
		thirdZmAppSecretData.Val,
		args["gid"],
		masterPid,
		pid,
		"",
		miniApp,
		"0", isShares)
	if err != nil {
		return nil, err
	}

	return urls, nil
}

func TikTokTurnChain(eg *xorm.Engine, officialEg, zhimengEg *xorm.Engine, dbName string, args map[string]string) (*md.ConvertedUrls, error) {
	couponShareURL := ""
	itemUrl := args["itemUrl"]
	if strings.Contains(args["gid"], "csjp") {
		args["provider"] = "csjp"
		args["gid"] = strings.ReplaceAll(args["gid"], "csjp", "")
	}
	if itemUrl != "" && (strings.Contains(itemUrl, "ins_activity_param=") || strings.Contains(itemUrl, "pick_source=")) || (zhios_third_party_utils.StrToInt(args["tik_activity_id"]) > 0) {
		tikTokBase, _ := tik_tok.Base(eg, dbName, "")
		if zhios_third_party_utils.StrToInt(args["tik_activity_id"]) > 0 {
			url := TikTokUrl(eg, dbName, args["gid"], args["tik_activity_id"])
			if url != "" {
				tikTokBase.TeamAccessToken = args["tik_team_token"]
				itemUrl = url
			}
		}
		postData := map[string]interface{}{
			"product_url": itemUrl,
			"pick_extra":  dbName + "_" + args["uid"],
		}
		fmt.Println(postData)
		detailUrlData, err := tik_tok.OwnTeamUrl(tikTokBase, postData)
		fmt.Println(detailUrlData)
		if err == nil && detailUrlData["product_url"] != "" {
			couponShareURL = detailUrlData["product_url"]
		}
	}

	if couponShareURL == "" {
		couponShareURL = "https://haohuo.jinritemai.com/views/product/item2?id=" + args["gid"]
	}
	args["coupon_url"] = couponShareURL
	urls, err := ConvertUrl(eg, officialEg, zhimengEg, args)
	if err != nil {
		return nil, err
	}
	return urls, nil
}
func ConvertUrl(eg *xorm.Engine, officialEg, zhimengEg *xorm.Engine, args map[string]string) (*md.ConvertedUrls, error) {
	var (
		err error
	)
	var urls *md.ConvertedUrls
	switch args["provider"] {
	case md.PVD_TB, md.PVD_TM:
		taobaoSdk, err := taobao.NewTaobaoSDK(eg, args["master_id"], args["platform"], zhios_third_party_utils.StrToInt(args["acc_taobao_share_id"]), args["union_id"])
		if err != nil {
			return nil, err
		}
		tb := taobaoSdk
		var promoId = tb.CloudPromoIdWeb
		if promoId == "" {
			promoId = tb.SharePromoIdWeb
		}
		var promoId1 string
		var taobaoShareId1 string
		var IsWxTaobaoAuth bool
		fmt.Println(IsWxTaobaoAuth)
		if zhios_third_party_utils.StrToInt(args["acc_taobao_share_id"]) == 0 {
			if tb.AppletIsAuth == "1" {
				IsWxTaobaoAuth, taobaoShareId1, promoId1 = taobao.TaobaoRelationPid(eg, args)
				if IsWxTaobaoAuth == false {
					return nil, err
				} else {
					promoId = promoId1
				}
				if taobaoShareId1 != "" {
					args["acc_taobao_share_id"] = taobaoShareId1
				}
			}
		}
		thirdZmAppKeyData, err := db.SysCfgGetOne(eg, "third_zm_app_key")
		if thirdZmAppKeyData == nil || err != nil {
			return urls, err
		}
		thirdZmAppSecretData, err := db.SysCfgGetOne(eg, "third_zm_app_secret")
		if thirdZmAppSecretData == nil || err != nil {
			return urls, err
		}
		urls, err = taobaoSdk.WnConvertUrlSC(args["gid"], "4", promoId, args["acc_taobao_share_id"])
	case md.PVD_JDS:
		thirdZmAppKeyData, err := db.SysCfgGetOne(eg, "third_zm_app_key")
		if thirdZmAppKeyData == nil || err != nil {
			return urls, err
		}
		thirdZmAppSecretData, err := db.SysCfgGetOne(eg, "third_zm_app_secret")
		if thirdZmAppSecretData == nil || err != nil {
			return urls, err
		}
		// 初始化京东配置
		pid := args["acc_jd_share_id"]
		postData := make(map[string]interface{})
		postData["gid"] = args["gid"]
		postData["appkey"] = thirdZmAppKeyData.Val
		postData["secret_key"] = thirdZmAppSecretData.Val
		couponUrl := ""
		couponPrice := ""
		mdData, err := cps_jd.JdDetailGoods(eg, args["master_id"], postData)
		if err == nil && mdData != nil && mdData.CouponURL != "" {
			couponUrl = mdData.CouponURL
			couponPrice = mdData.CouponPrice
		}
		urls, err = cps_jd.JdUrl(eg, args["master_id"], args["uid"], "3", thirdZmAppKeyData.Val,
			thirdZmAppSecretData.Val,
			args["gid"],
			pid,
			couponUrl,
			couponPrice,
			"")
	case md.PVD_TIKTOK, md.PVD_KUAISHOU, "csjp":
		pid := "cloud_" + args["uid"]
		thirdZmAppKeyData, err := db.SysCfgGetOne(eg, "third_zm_app_key")
		if thirdZmAppKeyData == nil || err != nil {
			return urls, err
		}
		thirdZmAppSecretData, err := db.SysCfgGetOne(eg, "third_zm_app_secret")
		if thirdZmAppSecretData == nil || err != nil {
			return urls, err
		}
		tikTokArgs := map[string]interface{}{
			"appkey":        thirdZmAppKeyData.Val,
			"secret_key":    thirdZmAppSecretData.Val,
			"product_url":   args["coupon_url"],
			"external_info": pid,
		}

		if args["provider"] == md.PVD_TIKTOK {
			tikTokArgs["need_qr_code"] = "0"

			tikTokBase, _ := tik_tok.Base(eg, args["master_id"], "")
			if zhios_third_party_utils.InArr(tikTokBase.AuthType, []string{"2", "3"}) {
				if time.Now().Unix() > 1670055300 {
					tikTokArgs["external_info"] = pid + "_" + args["master_id"]
				}
				urls, err = tik_tok.OwnTikTokUrl(tikTokBase, tikTokArgs)
			} else {
				tikTokArgs["external_info"] = pid + "_" + args["master_id"]
				urls, err = zhimeng.TikTokUrl(tikTokArgs)
			}

		} else if args["provider"] == "csjp" {
			tikTokArgs["need_qr_code"] = "0"
			tikTokArgs["external_info"] = pid + "_" + args["master_id"]
			base := Base(eg, officialEg, args["master_id"], "")
			args := map[string]string{
				"app_id":        base["app_id"],
				"app_secret":    base["app_secret"],
				"product_url":   zhios_third_party_utils.AnyToString(tikTokArgs["product_url"]),
				"external_info": zhios_third_party_utils.AnyToString(tikTokArgs["external_info"]),
				"share_type":    "1,3,5",
			}
			send := ""
			send, err = tik_tok.CsjpGoodsLink(args)
			urls = &md.ConvertedUrls{
				URL:          gjson.Get(send, "data.dy_deeplink").String(),
				ShortenURL:   gjson.Get(send, "data.dy_deeplink").String(),
				NoOpenAppURL: gjson.Get(send, "data.dy_deeplink").String(),
				AppURL:       gjson.Get(send, "data.dy_deeplink").String(),
				ClickUrl:     gjson.Get(send, "data.dy_deeplink").String(),
				H5Url:        gjson.Get(send, "data.dy_share_link").String(),
				QrcodeUrl:    gjson.Get(send, "data.dy_qr_code").String(),
				Content:      gjson.Get(send, "data.dy_password").String(),
			}
		} else if args["provider"] == md.PVD_KUAISHOU {
			tikTokArgs["gid"] = args["gid"]
			tikTokArgs["linkType"] = "101"
			tikTokArgs["genPoster"] = "0"
			tikTokArgs["external_info"] = pid + "_" + args["master_id"]
			urls = KuaiShouUrl(eg, officialEg, zhimengEg, args["master_id"], tikTokArgs)

		}
	case md.PVD_VIP:
		// 初始化vip配置
		pid := args["master_id"] + "_vip_cloud_" + args["uid"]
		openId := args["master_id"] + "_vip_" + args["uid"]
		union, _ := db.SysUnionByPVDByUse(eg, args["master_id"], "vip")
		authType := "0"
		if union != nil && union.AuthType == 2 {
			pid = "own_cloud_" + args["master_id"] + "_" + args["uid"]
			authType = "2"
			openId = pid
		}
		if authType == "2" {
			urls, err = zhimeng.OwnWphConvertUrl(union, args["gid"],
				pid,
				"", "vendoapi", openId, "1")
		} else {
			thirdZmAppKeyData, err := db.SysCfgGetOne(eg, "third_zm_app_key")
			if thirdZmAppKeyData == nil || err != nil {
				return urls, err
			}
			thirdZmAppSecretData, err := db.SysCfgGetOne(eg, "third_zm_app_secret")
			if thirdZmAppSecretData == nil || err != nil {
				return urls, err
			}

			urls, err = zhimeng.VipConvertUrl(
				thirdZmAppKeyData.Val,
				thirdZmAppSecretData.Val,
				args["gid"],
				pid,
				"", "vendoapi", openId, "1")
		}

	case md.PVD_PDD:
		pid := args["acc_pdd_self_id"]
		union, _ := db.SysUnionByPVDByUse(eg, args["master_id"], "pdd")
		authType := "0"
		if union != nil && union.AuthType == 2 {
			pid = "own_" + args["master_id"] + "_" + args["uid"]
			authType = "2"
		}
		miniApp := "0"
		isShares := "2"
		if authType == "2" {
			urls, err = zhimeng.OwnPDDConvertUrl(union, args["gid"], pid, "", miniApp, "", isShares)
		} else {
			thirdZmAppKeyData, err := db.SysCfgGetOne(eg, "third_zm_app_key")
			if thirdZmAppKeyData == nil || err != nil {
				return urls, err
			}
			thirdZmAppSecretData, err := db.SysCfgGetOne(eg, "third_zm_app_secret")
			if thirdZmAppSecretData == nil || err != nil {
				return urls, err
			}

			masterPid := pid

			pddPidData, _ := pdd.NewZhiMengPDDSDK().
				SelectFunction("get_pid_list").
				WithArgs(map[string]interface{}{
					"appkey":     db.SysCfgGetWithDb(eg, args["master_id"], md.KEY_CFG_ZM_AK),
					"secret_key": db.SysCfgGetWithDb(eg, args["master_id"], md.KEY_CFG_ZM_SK),
					"pid":        masterPid},
				).Result()
			if pddPidData != nil {
				b, _ := json.Marshal(pddPidData.ToInterface())
				pddPid := gjson.GetBytes(b, "pdd_pid").String()
				if pddPid == "" {
					profile, _ := db.UserProfileFindByID(eg, 0)
					if profile != nil {
						masterPid = profile.AccPddSelfId
					}
				}
			} else {
				profile, _ := db.UserProfileFindByID(eg, 0)
				if profile != nil {
					masterPid = profile.AccPddSelfId
				}
			}
			urls, err = zhimeng.PDDConvertUrl(
				thirdZmAppKeyData.Val,
				thirdZmAppSecretData.Val,
				args["gid"],
				masterPid,
				pid,
				"",
				miniApp,
				"0", isShares)
		}
	}
	return urls, err
}
func Base(eg *xorm.Engine, officialEg *xorm.Engine, dbName, unionId string) map[string]string {
	var cfg *model.SysUnionSet
	if zhios_third_party_utils.StrToInt(unionId) == 0 {
		cfg, _ = db.SysUnionByTikTokByUseByAuth(eg, dbName)
	} else {
		cfg = db.SysUnionById(eg, unionId)
	}
	tikTokCsjpAppId := offical.SysCfgByKeyStr(officialEg, "tik_tok_csjp_app_id")
	tikTokCsjpAppSecret := offical.SysCfgByKeyStr(officialEg, "tik_tok_csjp_app_secret")
	var tmp = map[string]string{
		"app_id":     tikTokCsjpAppId,
		"app_secret": tikTokCsjpAppSecret,
	}
	if cfg != nil && cfg.AuthType == 2 {
		tmp = map[string]string{
			"app_id":     gjson.Get(cfg.KeyData, "appId").String(),
			"app_secret": gjson.Get(cfg.KeyData, "appSecret").String(),
		}
	}
	return tmp
}

func TikTokUrl(eg *xorm.Engine, dbName string, gid, activityId string) string {
	tikTokBase, _ := tik_tok.Base(eg, dbName, "")
	postData := make(map[string]interface{})
	postData["gid"] = gid
	postData["appkey"] = db.SysCfgGetWithDb(eg, dbName, md.KEY_CFG_ZM_AK)
	postData["secret_key"] = db.SysCfgGetWithDb(eg, dbName, md.KEY_CFG_ZM_SK)
	postData["category_id"] = activityId
	postData["p"] = "1"
	postData["size"] = "1"
	tikTokBase.ExtendTeamTokenMap = GetTikTokTeamTokenEg(eg, dbName, "")

	list, _ := tik_tok.OwnTeamGoods(tikTokBase, postData)
	fmt.Println(list)
	url := ""
	if list != nil {
		for _, v := range *list {
			if v.GoodsID == gid {
				url = v.DetailURL
			}
		}
	}
	return url
}
func CheckTaobaoWordGetTkl(eg *xorm.Engine, dbName string, s string, args map[string]string) (string, string, string) {
	taobaoSdk, _ := taobao.NewTaobaoSDK(eg, dbName, args["platfrom"], zhios_third_party_utils.StrToInt(args["acc_taobao_share_id"]), args["union_id"])
	if taobaoSdk == nil {
		return "", "", ""
	}
	if strings.Contains(s, "taobao.com") || strings.Contains(s, "tmall.com") {
		bizSceneId := ""
		url := strings.ReplaceAll(s, "?", "&") + "&"
		split := strings.Split(url, "&id=")
		if len(split) == 2 {
			split1 := strings.Split(split[1], "&")
			if len(split1) > 0 {
				goodsId := split1[0]
				if php2go.IsNumeric(goodsId) {
					bizSceneId = "2"
				}
			}
		}
		s1 := s
		itemInfo, err := taobaoSdk.ItemDetailByLink(s1, bizSceneId)
		if itemInfo == nil || err != nil {
			return "", "", ""
		}
		return "", zhios_third_party_utils.AnyToString(itemInfo.ItemID), ""
	}

	urls, _ := taobaoSdk.WnConvertUrlSC(s, "2", taobaoSdk.CloudPromoIdWeb, args["acc_taobao_share_id"])
	if urls != nil {
		if urls.IsDown == "2" {
			return "", "", ""
		}
		taokou := &md.TaobaoWord{
			Text: urls.Tkl,
			Code: urls.ShortTkl,
		}
		urls.TaoBaoWord = WordDeal(eg, args["master_id"], taokou)
	}
	if urls != nil {
		return urls.TaoBaoWord, urls.ItemId, urls.IsDown
	}
	return "", "", ""
}

// 淘口令
func CheckTaobaoWordGetId(eg *xorm.Engine, dbName string, s string, args map[string]string) string {
	taobaoSdk, _ := taobao.NewTaobaoSDK(eg, dbName, args["platfrom"], zhios_third_party_utils.StrToInt(args["acc_taobao_share_id"]), args["union_id"])
	if taobaoSdk == nil {
		return ""
	}
	urls, _ := taobaoSdk.WnConvertUrlSC(s, "2", taobaoSdk.SelfPromoIdWeb, args["acc_taobao_share_id"])
	if urls == nil {
		return ""
	}
	// 查无数据
	if urls.ItemId == "" {
		return ""
	}
	return urls.ItemId
}
func CommGetGoods(eg *xorm.Engine, officialEg, zhimengEg *xorm.Engine, tmp map[string]string, tcPrase md.TCPrase, isFirst int, reqCount, pvd, goodsId, countUrl, tklWord, isTkl string) (md.TCPrase, string) {
	newPvd := pvd
	now := time.Now()
	if pvd == "tb_activity" && tklWord != "" {
		var urls = &md.ConvertedUrls{}
		urls.TaoBaoWord = tklWord
		tcPrase.Count = strings.ReplaceAll(reqCount, countUrl, tklWord)
		tcPrase.SuccessCount = zhios_third_party_utils.IntToStr(zhios_third_party_utils.StrToInt(tcPrase.SuccessCount) + 1)
		reqCount = tcPrase.Count
		return tcPrase, reqCount
	}
	fmt.Println("======================这里", time.Since(now))
	goods, pvd, _, _, _, _, _, mddata := ProcessTurnChainByGoodsId(eg, officialEg, tmp, goodsId, pvd, countUrl)
	fmt.Println("======================这里1", time.Since(now))
	oldCountUrl := countUrl
	var urls = &md.ConvertedUrls{}
	var err error
	if len(tklWord) <= 3 {
		tklWord = ""
	}
	if tklWord != "" && zhios_third_party_utils.InArr(pvd, []string{md.PVD_TIKTOKLIFE, md.PVD_TIKTOK, md.PVD_KUAISHOU, md.PVD_TM, md.PVD_TB}) {
		urls.TaoBaoWord = tklWord
	} else if tklWord != "" && zhios_third_party_utils.InArr(newPvd, []string{md.PVD_TIKTOKLIFE, md.PVD_TIKTOK}) {
		urls.TaoBaoWord = tklWord
	} else {

		if goods != nil {
			if goods.ClickUrl != "" {
				urls.ShortenURL = goods.ClickUrl
				urls.URL = goods.ClickUrl
			} else {
				//通过商品id转链
				tikTokBase := make(map[string]string)
				tikTokBase["gid"] = goods.GoodID
				if goods.GoodID == "" {
					tikTokBase["gid"] = goodsId
				}
				tikTokBase["pvd"] = pvd
				user, _ := db.UserFindByID(eg, tmp["uid"])
				for k1, v1 := range tmp {
					tikTokBase[k1] = v1
				}
				if pvd == md.PVD_PDD {
					tikTokBase["gid"] = goods.GoodID
					if goods.GoodID == "" {
						tikTokBase["gid"] = goodsId
					}
				}
				tikTokBase["itemUrl"] = countUrl
				urls, err = TurnChainFeatures(eg, officialEg, zhimengEg, tikTokBase, user)
				if err != nil || urls == nil {
					return tcPrase, reqCount
				}
				if pvd == md.PVD_TIKTOK && urls.Content != "" {
					urls.TaoBaoWord = urls.Content
					tklWord = urls.Content
				}
			}

		}

	}
	fmt.Println("======================这里2", time.Since(now))

	if goods == nil {
		goods = &md.ProductDetailResponse{}
	}
	if isFirst == 1 {
		copier.Copy(&tcPrase, mddata)
		tcPrase.ProductDetail = goods
		tcPrase.Count = reqCount
		tcPrase.Tkl = urls.TaoBaoWord
		tcPrase.TurnChainLink = urls.ShortenURL
	}
	if pvd != md.PVD_TB && pvd != md.PVD_TM && countUrl != "" && tklWord == "" {
		if urls.ShortenURL == "" {
			tcPrase.Count = strings.ReplaceAll(reqCount, countUrl, "")
			tcPrase.Count = strings.ReplaceAll(tcPrase.Count, "[[", "[")
			tcPrase.Count = strings.ReplaceAll(tcPrase.Count, "]]", "]")
		} else {
			tcPrase.Count = strings.ReplaceAll(reqCount, countUrl, urls.ShortenURL)
		}
	}
	isNull := ""
	if pvd != md.PVD_TB && pvd != md.PVD_TM && oldCountUrl != "" && countUrl == "" && tklWord == "" {
		isNull = "1"
		tcPrase.Count = strings.ReplaceAll(reqCount, oldCountUrl, "")
		tcPrase.Count = strings.ReplaceAll(tcPrase.Count, "[[", "[")
		tcPrase.Count = strings.ReplaceAll(tcPrase.Count, "]]", "]")
	}
	fmt.Println(isNull)
	if (pvd == md.PVD_TIKTOKLIFE || pvd == md.PVD_TIKTOK || newPvd == md.PVD_TIKTOK || pvd == md.PVD_TB || pvd == md.PVD_TM) && tklWord != "" {
		tcPrase.Count = strings.ReplaceAll(reqCount, countUrl, tklWord)
	}
	if pvd == md.PVD_KUAISHOU && tklWord != "" {
		tcPrase.Count = strings.ReplaceAll(reqCount, countUrl, tklWord)
	}
	if (pvd == md.PVD_TB || pvd == md.PVD_TM) && tklWord == "" {
		word, _ := ReplaceTbAll(eg, urls.ShortenURL, tmp)
		tcPrase.Tkl = word
		if countUrl != "" && strings.Contains(countUrl, "http") {
			tcPrase.Count = strings.ReplaceAll(reqCount, countUrl, "")
		}
		if tklWord != "" && countUrl != "" { //获取到旧的淘口令
			tcPrase.Count = strings.ReplaceAll(tcPrase.Count, tklWord, word)
		} else if tklWord != "" && countUrl == "" { //获取到旧的淘口令
			tcPrase.Count = strings.ReplaceAll(reqCount, tklWord, word)
		} else {
			split := strings.Split(tcPrase.Count, " ")
			if split != nil && len(split) > 0 {
				tcPrase.Count = strings.ReplaceAll(tcPrase.Count, split[0], word)
			}
		}
	}
	reqCount = tcPrase.Count
	return tcPrase, reqCount
}
func ReplaceTbAll(eg *xorm.Engine, url string, args map[string]string) (taoBaoWord, shortURL string) {
	taobaoSdk, err := taobao.NewTaobaoSDK(eg, args["master_id"], args["platform"], zhios_third_party_utils.StrToInt(args["acc_taobao_share_id"]), args["union_id"])
	if err != nil {
		return
	}
	// 生成淘口令
	taokou, err := taobaoSdk.WordCreate(url, "12345")
	if err != nil {
		taokou = new(md.TaobaoWord)
	}
	taoBaoWord = WordDeal(eg, args["master_id"], taokou)
	//shortURL, _ = baidu.ShortenUrl(url)
	return
}
func WordDeal(eg *xorm.Engine, dbName string, word *md.TaobaoWord) string {
	tbTurnWordType := db.SysCfgGetWithDb(eg, dbName, "tb_share_word_type")
	tbTurnWordFormat := db.SysCfgGetWithDb(eg, dbName, "tb_share_word_format")
	tbTurnWordLeft := db.SysCfgGetWithDb(eg, dbName, "tb_share_word_left")
	tbTurnWordRight := db.SysCfgGetWithDb(eg, dbName, "tb_share_word_right")
	tbTurnWordType = db.SysCfgGetWithDb(eg, dbName, "tb_turn_word_type")
	tbTurnWordFormat = db.SysCfgGetWithDb(eg, dbName, "tb_turn_word_format")
	tbTurnWordLeft = db.SysCfgGetWithDb(eg, dbName, "tb_turn_word_left")
	tbTurnWordRight = db.SysCfgGetWithDb(eg, dbName, "tb_turn_word_right")
	taoBaoWord := zhios_third_party_utils.IntToStr(rand.Intn(9)) + " " + tbTurnWordLeft + word.Code + "/" + tbTurnWordRight
	taoBaoWords := strings.Split(word.Text, "http")
	if len(taoBaoWords) > 0 {
		split := strings.Split(taoBaoWords[0], "￥")
		wordStr := taoBaoWords[0]
		if len(split) > 0 && tbTurnWordLeft != "" {
			wordStr = strings.ReplaceAll(wordStr, split[0], "")
		}
		tbTurnWordRight = strings.ReplaceAll(tbTurnWordRight, "????", "🍑")
		taoBaoWord = tbTurnWordLeft + wordStr + tbTurnWordRight
	}
	if tbTurnWordType != "1" {
		taoBaoWord = word.Text
	}
	if tbTurnWordFormat != "" {
		split := strings.Split(tbTurnWordFormat, "_")
		tbsplit := strings.Split(taoBaoWord, "￥")
		taoBaoWord = ""
		for k, v := range tbsplit {
			if k < 2 {
				taoBaoWord += v + split[k]
			} else {
				taoBaoWord += v
			}
		}
	}
	return taoBaoWord
}

// 淘口令判断
func FindTaobaoWord(eg *xorm.Engine, officialEg, zhimengEg *xorm.Engine, tmp map[string]string, reqCount string, user *model.User) (pvd, goodsId, tklWord, url string) {
	dbName := tmp["master_id"]
	if strings.Contains(reqCount, "haohuo.jinritemai.") {
		//https://haohuo.jinritemai.com/ecommerce/trade/detail/index.html?id=3556342393857024570&ins_activity_param=yNAkhfs&origin_type=pc_buyin_group&pick_source=v.6nZos
		tikTokBase := CommTik(eg, dbName, reqCount)
		url := strings.ReplaceAll(reqCount, "?", "&") + "&"
		split := strings.Split(url, "&id=")
		if len(split) == 2 {
			split1 := strings.Split(split[1], "&")
			if len(split1) > 0 {
				goodsId = split1[0]
				tikTokBase["gid"] = goodsId
				tikTokBase["pvd"] = pvd
				for k1, v1 := range tmp {
					tikTokBase[k1] = v1
				}
				tikTokBase["itemUrl"] = reqCount
				urls, err := TurnChainFeatures(eg, officialEg, zhimengEg, tikTokBase, user)
				if err != nil || urls == nil {
					return "", "", "", ""
				}
				if zhios_third_party_utils.StrToInt(tikTokBase["tik_activity_id"]) > 0 && strings.Contains(goodsId, "cid") == false {
					goodsId += "cid" + tikTokBase["tik_activity_id"]
				}
				return md.PVD_TIKTOK, goodsId, urls.Content, ""
			}
		}
	}
	if strings.Contains(reqCount, "【快手】") {
		info, _ := CheckKuaishouWord(eg, officialEg, zhimengEg, dbName, reqCount, user, 1)
		if info != nil {
			return md.PVD_KUAISHOU, info.ItemId, info.Word, ""
		}
	}
	if strings.Contains(reqCount, "dou音") || strings.Contains(reqCount, "buydouke") || (strings.Contains(reqCount, "抖音") || strings.Contains(reqCount, "douyin")) && strings.Contains(reqCount, "【") {
		info := CheckTikTokWord(eg, officialEg, zhimengEg, dbName, reqCount, user, 0)
		activityId := ""
		pvd1 := md.PVD_TIKTOK
		if info != nil {
			if info.Pvd == md.PVD_TIKTOKLIFE {
				return md.PVD_TIKTOKLIFE, info.ItemId, info.Word, info.Url
			}
			goodsId = info.ItemId
			activityId = info.ActivityId
			if info.IsCsjp == "1" {
				pvd1 = "csjp"
			}
		}
		var curls = new(md.ConvertedUrls)
		var err error
		if activityId != "" {
			needQrCode := "0"
			pid := "s_" + zhios_third_party_utils.IntToStr(user.Uid) + "_" + dbName
			tikTokArgs := map[string]interface{}{
				"appkey":        db.SysCfgGetWithDb(eg, dbName, md.KEY_CFG_ZM_AK),
				"secret_key":    db.SysCfgGetWithDb(eg, dbName, md.KEY_CFG_ZM_SK),
				"need_qr_code":  needQrCode,
				"external_info": pid,
				"material_id":   "",
			}

			tikTokBase, _ := tik_tok.Base(eg, dbName, "")
			tikTokArgs["material_id"] = activityId
			var actUrls *md.ConvertedUrls
			if zhios_third_party_utils.InArr(tikTokBase.AuthType, []string{"2", "3"}) {
				actUrls, err = tik_tok.OwnTikTokActUrl(tikTokBase, tikTokArgs)
			} else {
				tikTokArgs["material_id"] = activityId
				actUrls, _ = zhimeng.TikTokActUrl(tikTokArgs)
			}
			if actUrls != nil {
				curls.Content = actUrls.Content
			}
		} else {
			args := make(map[string]string)
			args["gid"] = ""
			args["coupon_url"] = reqCount
			args["master_id"] = dbName
			args["provider"] = pvd1
			args["uid"] = zhios_third_party_utils.IntToStr(user.Uid)
			curls, err = ConvertUrl(eg, officialEg, zhimengEg, args)
		}
		if err != nil {
			return "", "", "", ""
		}
		if curls == nil {
			return "", "", "", ""
		}
		if curls.Content == "" {
			return "", "", "", ""
		}
		return md.PVD_TIKTOK, goodsId, curls.Content, ""
	}
	goodsParam := make(map[string]string)
	goodsParam["gid"] = ""
	goodsParam["platform"] = tmp["platform"]
	goodsParam["master_id"] = dbName
	userProfile, _ := db.UserProfileFindByID(eg, user.Uid)
	if userProfile != nil {
		//新的渠道id 存储
		relation := db.GetTaobaoUserRelationByUid(eg, userProfile.Uid)
		if relation != nil {
			userProfile.AccTaobaoShareId = relation.RelationId
			goodsParam["union_id"] = zhios_third_party_utils.IntToStr(relation.UnionId)
		}
		goodsParam["acc_taobao_share_id"] = zhios_third_party_utils.Int64ToStr(userProfile.AccTaobaoShareId)
		if userProfile.AccJdCloudId == "" {
			userProfile.AccJdCloudId = userProfile.AccJdShareId
		}
		goodsParam["acc_jd_share_id"] = userProfile.AccJdCloudId
		goodsParam["acc_pdd_self_id"] = userProfile.AccPddSelfId
		goodsParam["acc_vip_self_id"] = userProfile.AccVipShareId

	}
	//判断如果是有纯字母 字母+数字的内容 并且没有链接的 都调淘宝接口
	split := regexp.MustCompile("[a-zA-Z0-9]{9,14}").FindAllString(reqCount, -1)
	//split_letter := regexp.MustCompile("[a-zA-Z]{8,15}").FindAllString(reqCount, -1)
	split1 := regexp.MustCompile("[a-zA-Z0-9]{6,15} [a-zA-Z0-9]{6,15}").FindAllString(reqCount, -1)

	if len(split1) > 0 || strings.Contains(reqCount, "tb.cn") {
		tkl, ItemId, isDown := CheckTaobaoWordGetTkl(eg, dbName, reqCount, goodsParam)
		pvds := md.PVD_TB
		if isDown == "1" {
			pvds = ""
		}
		return pvds, ItemId, tkl, ""
	}
	//判断是不是有淘宝链接
	if strings.Count(reqCount, "€") >= 1 || strings.Contains(reqCount, "tb.cn") {

		tkl, ItemId, isDown := CheckTaobaoWordGetTkl(eg, dbName, reqCount, goodsParam)
		pvds := md.PVD_TB
		if isDown == "1" {
			pvds = ""
		}
		return pvds, ItemId, tkl, ""
	}
	//split_letter := regexp.MustCompile("[a-zA-Z]{8,15}").FindAllString(reqCount, -1)
	if split != nil && ((zhios_third_party_utils.IsChineseChar(reqCount) && strings.Contains(reqCount, "http")) || strings.Contains(reqCount, "http") == false) {
		var is_tkl = 0
		for k, v := range split {
			if k == 0 {
				is_tkl = 1
				tklWord = v
			}
		}

		if is_tkl == 1 {
			tkl, ItemId, isDown := CheckTaobaoWordGetTkl(eg, dbName, reqCount, goodsParam)
			pvds := md.PVD_TB
			if isDown == "1" {
				pvds = ""
			}
			return pvds, ItemId, tkl, ""
		}
	}
	if strings.Contains(reqCount, "http") == false {
		if tmp["platType"] != "taobao" {
			info := CheckTikTokWord(eg, officialEg, zhimengEg, dbName, reqCount, user, 1)
			if info != nil {

				return md.PVD_TIKTOK, info.ItemId, info.Word, info.Url
			}
			info, _ = CheckKuaishouWord(eg, officialEg, zhimengEg, dbName, reqCount, user, 1)
			if info != nil {
				return md.PVD_KUAISHOU, info.ItemId, info.Word, ""
			}
		}
		if len(reqCount) > 16 {
			taobaoWord := CheckTaobaoWordGetId(eg, dbName, reqCount, goodsParam)
			if taobaoWord != "" {
				return md.PVD_TB, taobaoWord, tklWord, ""
			}
		}
	}
	if strings.Contains(strings.ToLower(reqCount), "taobao.com") || strings.Contains(strings.ToLower(reqCount), "tmall.com") {
		tkl, ItemId, isDown := CheckTaobaoWordGetTkl(eg, dbName, reqCount, goodsParam)
		pvds := md.PVD_TB
		if isDown == "1" {
			pvds = ""
		}
		return pvds, ItemId, tkl, ""
	}
	if strings.Contains(reqCount, "s.click.Taobao") {
		tkl, ItemId, isDown := CheckTaobaoWordGetTkl(eg, dbName, reqCount, goodsParam)
		pvds := md.PVD_TB
		if isDown == "1" {
			pvds = ""
		}
		return pvds, ItemId, tkl, ""
	}
	return
}
func CheckTaobao(eg *xorm.Engine, officialEg, zhimengEg *xorm.Engine, dbName, s string, args map[string]string) *md.ItemParseInfo {
	bizSceneId := ""
	taobaoSdk, _ := taobao.NewTaobaoSDK(eg, args["master_id"], args["platform"], zhios_third_party_utils.StrToInt(args["acc_taobao_share_id"]), args["union_id"])
	if taobaoSdk == nil {
		return nil
	}

	if strings.Contains(s, "s.click.Taobao") {
		gid := CheckTaobaoWordGetId(eg, dbName, s, args)
		if gid == "" {
			return nil
		}
		s = "https://uland.taobao.com/item/edetail?id=" + gid
		bizSceneId = ""
	}
	itemInfo, err := taobaoSdk.ItemDetailByLink(s, bizSceneId)
	if itemInfo == nil || err != nil {
		return nil
	}
	// 用户登陆, 就要转链

	couponUrl := itemInfo.URL
	//调用好单库
	//hdkItemInfo, itemInfo, providers := GetHdkDtkGoods(c, itemInfo, md.PVD_DTK)
	convertUrl, err := ConvertUrl(eg, officialEg, zhimengEg, args)
	if err == nil && convertUrl != nil {
		couponUrl = convertUrl.ShortenURL
	}
	provider := md.PVD_TB
	if itemInfo.UserType == 1 {
		provider = md.PVD_TM
	}
	return &md.ItemParseInfo{
		ItemId:    zhios_third_party_utils.AnyToString(itemInfo.ItemID),
		Provider:  provider,
		CouponUrl: couponUrl,
		APPUrl:    couponUrl,
		ShopName:  itemInfo.Nick,
	}
}
func CsjpGoodsKlNew(eg *xorm.Engine, officialEg *xorm.Engine, dbName string, tikTokArgs map[string]interface{}) (*zhimeng.TikTokDetailData, error) {
	base := Base(eg, officialEg, dbName, "")
	if base["app_id"] == "" {
		return nil, nil
	}
	args := map[string]string{
		"app_id":     base["app_id"],
		"app_secret": base["app_secret"],
		"command":    tikTokArgs["content"].(string),
	}
	for k, v := range args {
		if v == "<nil>" {
			args[k] = ""
		}
	}
	var data = zhimeng.TikTokDetailData{}
	goods := tik_tok.CsjpKeyword(args)
	if goods.ActivityId != "" {
		data.ActivityId = goods.ActivityId
		return &data, nil
	}

	if goods.GoodsID == "" {
		return nil, nil
	}
	err := copier.Copy(&data, goods)
	if err != nil {
		return nil, nil
	}
	if zhios_third_party_utils.StrToFloat64(data.YhqPrice) > 0 {
		data.Price = data.CostPrice
	}
	data.GoodsID += "csjp"
	return &data, nil
}

func getFirstTikTokGoodsKl(eg *xorm.Engine, officialEg *xorm.Engine, dbName string, tikTokBase *md.TikTokBase, postData map[string]interface{}) (*zhimeng.TikTokDetailData, error) {
	tikTokFirstGoods := db.SysCfgGetWithDb(eg, dbName, "tik_tok_first_goods")
	var err error
	var itemData *zhimeng.TikTokDetailData
	isCsjp := "0"
	if tikTokFirstGoods != "1" {
		if zhios_third_party_utils.InArr(tikTokBase.AuthType, []string{"2", "3"}) {
			itemData, err = tik_tok.OwnTikTokGoodsKlNew(tikTokBase, postData)
		} else {
			itemData, err = zhimeng.TikTokGoodsKlNew(postData)
		}
		//if err != nil || itemData == nil || itemData.GoodsID == "" {
		//	itemData, err = CsjpGoodsKlNew(eg, officialEg, dbName, postData)
		//	isCsjp = "1"
		//}
	} else {
		itemData, err = CsjpGoodsKlNew(eg, officialEg, dbName, postData)
		isCsjp = "1"
		//if err != nil || itemData == nil || itemData.GoodsID == "" {
		//	if zhios_third_party_utils.InArr(tikTokBase.AuthType, []string{"2", "3"}) {
		//		itemData, err = tik_tok.OwnTikTokGoodsKlNew(tikTokBase, postData)
		//	} else {
		//		itemData, err = zhimeng.TikTokGoodsKlNew(postData)
		//	}
		//	isCsjp = "0"
		//}
	}
	if itemData != nil {
		itemData.IsCsjp = isCsjp
	}
	return itemData, err
}

func CheckTikTokWord(eg *xorm.Engine, officialEg, zhimengEg *xorm.Engine, dbName, s string, user *model.User, isChange int) *md.ItemParseInfo {
	var postData = map[string]interface{}{}
	postData["appkey"] = db.SysCfgGetWithDb(eg, dbName, md.KEY_CFG_ZM_AK)
	postData["secret_key"] = db.SysCfgGetWithDb(eg, dbName, md.KEY_CFG_ZM_SK)
	postData["content"] = s
	now := time.Now()
	tikTokBase, _ := tik_tok.Base(eg, dbName, "")
	itemData, err := getFirstTikTokGoodsKl(eg, officialEg, dbName, tikTokBase, postData)
	fmt.Println("1", time.Since(now))
	provider := md.PVD_TIKTOK
	word := s
	url := ""
	isCsjp := "0"
	if err != nil || itemData == nil {
		tikTokOpenUid := offical.MasterListCfgGetOneData(officialEg, "0", "tik_tok_open_uid")
		tikTokOpenPid := offical.MasterListCfgGetOneData(officialEg, "0", "tik_tok_open_pid")
		shareParams := map[string]interface{}{
			"pid":           tikTokOpenPid,
			"external_info": "s_" + zhios_third_party_utils.IntToStr(user.Uid) + "_" + dbName, //自定义字段，只允许数字、字母和_，限制⻓度为40
			"platform":      "0",
			"need_command":  true,
			"need_qr_code":  true,
		}
		param := map[string]interface{}{
			"uid":          tikTokOpenUid,
			"command":      s,           //商品ID/商品URL/短链/口令
			"share_params": shareParams, //转链参数，无需转链不传
		}
		api, _ := tik_tok.LocalApi("command_parse_and_share/", TikTokToken(officialEg), zhios_third_party_utils.SerializeStr(param))
		fmt.Println(api)
		productId := gjson.Get(api, "data.product_info.product_id").Int()
		if productId > 0 {
			word = gjson.Get(api, "data.product_info.share_info.dy_password").String()
			url = gjson.Get(api, "data.product_info.share_info.dy_deeplink").String()
			return &md.ItemParseInfo{
				Url:    url,
				Pvd:    md.PVD_TIKTOKLIFE,
				Word:   word,
				ItemId: zhios_third_party_utils.Int64ToStr(productId),
			}
		} else {
			return nil
		}
	}
	if itemData.ActivityId != "" {
		return &md.ItemParseInfo{ActivityId: itemData.ActivityId}
	}
	if itemData.GoodsID == "" {
		return nil
	}
	isCsjp = itemData.IsCsjp
	couponUrl := ""
	if user != nil {
		if isChange == 1 {
			args := make(map[string]string)
			args["gid"] = itemData.GoodsID
			args["master_id"] = dbName
			args["provider"] = provider
			if isCsjp == "1" {
				args["provider"] = "csjp"
			}
			args["uid"] = zhios_third_party_utils.IntToStr(user.Uid)
			convertUrl, err := ConvertUrl(eg, officialEg, zhimengEg, args)
			if err == nil && convertUrl != nil {
				couponUrl = convertUrl.AppURL
				word = convertUrl.Content
			}
		}
	}
	fmt.Println("2", time.Since(now))

	return &md.ItemParseInfo{
		IsCsjp:    isCsjp,
		Url:       url,
		Pvd:       provider,
		Word:      word,
		ItemId:    itemData.GoodsID,
		Provider:  provider,
		CouponUrl: couponUrl,
		APPUrl:    couponUrl,
	}

}

func TikTokToken(eg *xorm.Engine) string {
	tikTokOpenAppkey := offical.MasterListCfgGetOneData(eg, "0", "tik_tok_open_appkey")
	tikTokOpenAppSecret := offical.MasterListCfgGetOneData(eg, "0", "tik_tok_open_app_secret")
	args := map[string]string{
		"appkey":    tikTokOpenAppkey,
		"appSecret": tikTokOpenAppSecret,
	}
	key := "tikTok_client_" + args["appkey"]
	tokeStr, err := cache.GetString(key)
	if tokeStr == "" || err != nil {
		token := tik_tok.GetClientToken(args)
		if token["tik_tok_acc_token"] != "" {
			tokeStr = token["tik_tok_acc_token"]
			cache.SetEx(key, token["tik_tok_acc_token"], zhios_third_party_utils.StrToInt(token["expires_in"]))
		}
	}
	return tokeStr
}
func CheckKuaishouWord(eg *xorm.Engine, officialEg, zhimengEg *xorm.Engine, dbName string, s string, user *model.User, isChange int) (*md.ItemParseInfo, bool) {
	var postData = map[string]interface{}{}
	postData["appkey"] = db.SysCfgGetWithDb(eg, dbName, md.KEY_CFG_ZM_AK)
	postData["secret_key"] = db.SysCfgGetWithDb(eg, dbName, md.KEY_CFG_ZM_SK)
	postData["content"] = s
	itemData := KuaiShouKlGoods(eg, officialEg, zhimengEg, dbName, postData)

	if itemData == nil || itemData.GoodsID == "" {
		return nil, false
	}
	provider := md.PVD_KUAISHOU
	couponUrl := ""
	word := s

	if user != nil {
		if isChange == 1 {
			userProfile, _ := db.UserProfileFindByID(eg, user.Uid)
			args := make(map[string]string)
			if userProfile != nil {
				//新的渠道id 存储
				relation := db.GetTaobaoUserRelationByUid(eg, userProfile.Uid)
				if relation != nil {
					userProfile.AccTaobaoShareId = relation.RelationId
					args["union_id"] = zhios_third_party_utils.IntToStr(relation.UnionId)
				}
				args["acc_taobao_share_id"] = zhios_third_party_utils.Int64ToStr(userProfile.AccTaobaoShareId)
				if userProfile.AccJdCloudId == "" {
					userProfile.AccJdCloudId = userProfile.AccJdShareId
				}
				args["acc_jd_share_id"] = userProfile.AccJdCloudId
				args["acc_pdd_self_id"] = userProfile.AccPddSelfId
				args["acc_vip_self_id"] = userProfile.AccVipShareId

			}
			args["gid"] = itemData.GoodsID
			args["master_id"] = dbName
			args["provider"] = provider
			args["uid"] = zhios_third_party_utils.IntToStr(user.Uid)
			convertUrl, err := ConvertUrl(eg, officialEg, zhimengEg, args)
			if err == nil && convertUrl != nil {
				couponUrl = convertUrl.AppURL
				word = convertUrl.Content
			}
		}
	}

	return &md.ItemParseInfo{
		Word:      word,
		ItemId:    itemData.GoodsID,
		Provider:  provider,
		CouponUrl: couponUrl,
		APPUrl:    couponUrl,
		DetailUrl: itemData.DetailUrl,
	}, false

}

// 获取商品主入口
func ProcessTurnChainByGoodsId(eg *xorm.Engine, officialEg *xorm.Engine, tmp map[string]string, goodsId, pvd, url string) (productDetail *md.ProductDetailResponse, productPvd, itemUrl, couponShareURL, couponAmount, couponUrl, couponPrice string, resMd *md.MoreDetailResponse) {
	mdData := &md.MoreDetailResponse{}
	switch pvd {

	case md.PVD_KUAISHOU:
		tikTokResponse, tikTokProvider := KuaishouByGoodsID(eg, officialEg, tmp, goodsId, url, mdData)
		if tikTokResponse != nil && tikTokProvider != "" {
			return tikTokResponse, tikTokProvider, "", "", "", "", "", mdData
		} else {
			return
		}
	case md.PVD_TIKTOK:
		if goodsId == "" {
			return
		}
		tikTokResponse, tikTokProvider := TikTokByGoodsID(eg, officialEg, tmp, goodsId, url, mdData)
		if tikTokResponse != nil && tikTokProvider != "" {
			return tikTokResponse, tikTokProvider, "", "", "", "", "", mdData
		} else {
			return
		}
	case md.PVD_TB, md.PVD_TM:
		tbOrTmResponse, tbOrTmProvider, tbcouponShareURL, tbcouponAmount := TBByGoodsId(eg, officialEg, tmp, goodsId, url, mdData)
		if tbOrTmResponse != nil && tbOrTmProvider != "" { //taobaoOrTm
			return tbOrTmResponse, tbOrTmProvider, url, tbcouponShareURL, tbcouponAmount, "", "", mdData
		} else {
			return
		}
	case md.PVD_JD:
		jdResponse, jdProvider, jdCouponUrl, jdCouponPrice := JDByGoodsId(eg, officialEg, tmp, goodsId, url, mdData)
		if jdResponse != nil && jdProvider != "" {
			return jdResponse, jdProvider, "", "", "", jdCouponUrl, jdCouponPrice, mdData
		} else {
			return
		}
	case md.PVD_VIP:
		vipResponse, vipProvider := VIPByGoodsID(eg, officialEg, tmp, goodsId, url, mdData)
		if vipResponse != nil && vipProvider != "" {
			return vipResponse, vipProvider, "", "", "", "", "", mdData
		} else {
			return
		}
	case md.PVD_PDD:
		pddResponse, pddProvider := PDDByGoodsId(eg, officialEg, tmp, goodsId, url, mdData)
		if pddResponse != nil && pddProvider != "" {
			return pddResponse, pddProvider, "", "", "", "", "", mdData
		} else {
			return nil, "", "", "", "", "", "", mdData
		}
	default:
		return
	}
}

func KuaishouByGoodsID(eg *xorm.Engine, officialEg *xorm.Engine, tmp map[string]string, goodsId, url string, mdData *md.MoreDetailResponse) (*md.ProductDetailResponse, string) {

	r := &md.ProductDetailResponse{GoodID: goodsId}
	return r, md.PVD_KUAISHOU
}
func TikTokByGoodsID(eg *xorm.Engine, officialEg *xorm.Engine, tmp map[string]string, goodsId, url string, mdData *md.MoreDetailResponse) (*md.ProductDetailResponse, string) {

	r := &md.ProductDetailResponse{GoodID: goodsId}
	return r, md.PVD_TIKTOK
}
func TBByGoodsId(eg *xorm.Engine, officialEg *xorm.Engine, tmp map[string]string, goodsId, url string, mdData *md.MoreDetailResponse) (productDetail *md.ProductDetailResponse, pvd, couponShareURL, couponAmount string) {
	//获取到传进来的id先请求淘宝
	//根据prodId获取对应产品信息
	taobaoSdk, err := taobao.NewTaobaoSDK(eg, tmp["master_id"], tmp["platform"], zhios_third_party_utils.StrToInt(tmp["acc_taobao_share_id"]), tmp["union_id"])

	if err != nil {
		//e.OutErr(c, e.ERR_SYSUNION_CONFIG, err)
		return
	}
	var itemInfo *taobao.Material
	if goodsId != "" {
		itemInfo, err = taobaoSdk.ItemDetailById(goodsId, "")
	} else if strings.Contains(url, "http") {

		bizSceneId := ""
		urls := strings.ReplaceAll(url, "?", "&") + "&"
		split := strings.Split(urls, "&id=")
		if len(split) == 2 {
			split1 := strings.Split(split[1], "&")
			if len(split1) > 0 {
				goodsIds := split1[0]
				if php2go.IsNumeric(goodsIds) {
					bizSceneId = "2"
				}
			}
		}
		itemInfo, err = taobaoSdk.ItemDetailByLink(url, bizSceneId)
	}
	if err != nil {
		return
	}
	if itemInfo != nil {

		r := &md.ProductDetailResponse{}
		istaobaoURL := strings.Contains(itemInfo.ItemURL, "taobao.com")
		provider := md.PVD_TB
		if istaobaoURL {
			provider = md.PVD_TB
		} else {
			istmallURL := strings.Contains(itemInfo.ItemURL, "tmall.com")
			if istmallURL {
				provider = md.PVD_TM
			}
		}
		r.GoodID = zhios_third_party_utils.AnyToString(itemInfo.ItemID)
		return r, provider, itemInfo.CouponShareURL, itemInfo.CouponAmount
	}
	return
}
func JDByGoodsId(eg *xorm.Engine, officialEg *xorm.Engine, tmp map[string]string, goodsId, url string, mdData *md.MoreDetailResponse) (jdResponse *md.ProductDetailResponse, pvd, couponUrl, couponPrice string) {
	now := time.Now()
	fmt.Println("===zhe", time.Since(now))
	var jdData *zhimeng.SDK
	postData := make(map[string]interface{})
	postData["appkey"] = db.SysCfgGetWithDb(eg, tmp["master_id"], md.KEY_CFG_ZM_AK)
	postData["secret_key"] = db.SysCfgGetWithDb(eg, tmp["master_id"], md.KEY_CFG_ZM_SK)
	//请求jd
	var err error
	ClickUrl := ""
	isNull := ""
	auth, _ := db.SysUnionByJdByUseByAuth(eg, tmp["master_id"])
	if auth != nil {
		postData["union_type"] = zhios_third_party_utils.IntToStr(auth.AuthType)
	}
	if postData["union_type"] == "2" {
		if zhios_third_party_utils.StrToInt(goodsId) > 0 {
			postData["gid"] = goodsId
			mdData, err = cps_jd.JdDetailGoods(eg, tmp["master_id"], postData)
		} else {
			curls, _ := OfficialRecommendUrl(eg, tmp, "jd", 1, 0, 0, 0, "", "1", 0, url)
			if curls != nil && curls.Url != "" {
				fmt.Println("===zhe1", time.Since(now))
				ClickUrl = curls.Url
				//parse, _ = taoke.DaTaoKeContentParse(curls.Url)
				postData["keyword"] = url
				postData["size"] = "2"
				postData["p"] = "1"
				postData["is_url"] = "1"
				mdData, err = cps_jd.JdSearchGoodsUrl(eg, tmp["master_id"], postData)
				fmt.Println("===zhe2", time.Since(now))
			} else {
				isNull = "1"
			}
		}
		if mdData == nil {
			if ClickUrl != "" {
				return &md.ProductDetailResponse{ClickUrl: ClickUrl}, md.PVD_JD, "", ""
			}
			return &md.ProductDetailResponse{IsNull: isNull}, md.PVD_JD, "", ""
		}
	} else {
		if zhios_third_party_utils.StrToInt(goodsId) > 0 {
			postData["gid"] = goodsId
			jdData, err = jd.NewZhiMengJingDongSDK().
				SelectFunction("getgoodsinfo").
				WithArgs(postData).
				Result()
		} else {
			curls, _ := OfficialRecommendUrl(eg, tmp, "jd", 1, 0, 0, 0, "", "1", 0, url)
			if curls != nil && curls.Url != "" {
				fmt.Println("===zhe1", time.Since(now))

				ClickUrl = curls.Url
				//parse, _ = taoke.DaTaoKeContentParse(curls.Url)
				postData["keyword"] = url
				postData["size"] = "2"
				postData["p"] = "1"
				postData["is_url"] = "1"
				jdData, err = jd.NewZhiMengJingDongSDK().
					SelectFunction("new_getgoods").
					WithArgs(postData).
					Result()
				fmt.Println("===zhe2", time.Since(now))

			} else {
				isNull = "1"
			}
		}
		if jdData == nil {
			if ClickUrl != "" {
				return &md.ProductDetailResponse{ClickUrl: ClickUrl}, md.PVD_JD, "", ""
			}
			return &md.ProductDetailResponse{IsNull: isNull}, md.PVD_JD, "", ""
		}
		// scrap detail image
		if zhios_third_party_utils.StrToInt(goodsId) > 0 {
			jdData.WithJDDetailImageList(goodsId)
		}

		if err != nil {
			//e.OutErr(c, e.ERR_API_RESPONSE, e.NewErr(400, "商品已下架"))
			return nil, "", "", ""
		}
		// to struct
		err = jdData.ToStruct(mdData)
		if err != nil {
			//e.OutErr(c, e.ERR_INVALID_ARGS, err)
			return nil, "", "", ""
		}
	}
	if mdData != nil {
		if mdData.GID == "100038437991" || strings.Contains(mdData.GoodsTitle, "Apple iPhone") {
			return nil, "", "", ""
		}
		// to response
		r := &md.ProductDetailResponse{}
		r.ClickUrl = ClickUrl
		r.GoodID = mdData.GID
		return r, md.PVD_JD, mdData.CouponURL, mdData.CouponPrice
	}
	return nil, "", "", ""
}

func PDDByGoodsId(eg *xorm.Engine, officialEg *xorm.Engine, tmp map[string]string, goodsId, url string, mdData *md.MoreDetailResponse) (*md.ProductDetailResponse, string) {
	postData := make(map[string]interface{})
	isList := false
	if zhios_third_party_utils.StrToInt(goodsId) > 0 {
		postData["gid"] = goodsId
	} else {
		postData["keyword"] = url
		isList = true
	}
	postData["appkey"] = db.SysCfgGetWithDb(eg, tmp["master_id"], md.KEY_CFG_ZM_AK)
	postData["secret_key"] = db.SysCfgGetWithDb(eg, tmp["master_id"], md.KEY_CFG_ZM_SK)
	union, _ := db.SysUnionByPVDByUse(eg, tmp["master_id"], "pdd")

	if union != nil && union.AuthType == 2 {
		newpid := "own_" + tmp["master_id"] + "_" + tmp["uid"]
		slist1 := zhimeng.OwnPddSearchGoodsDetail(newpid, union, postData, false)
		err := zhimeng.OwnPddToStruct(slist1, mdData)
		if err != nil {

			//e.OutErr(c, e.ERR_INVALID_ARGS, err)
			return nil, ""
		}
	} else {
		//换为用搜索接口查商品
		var pddPid string
		var coustom string
		master, err := db.UserProfileFindByID(eg, 0)
		pddPid = master.AccPddSelfId
		coustom = master.AccPddSelfId
		postData["pid"] = pddPid
		postData["custom_parameters"] = coustom
		pddData, err := pdd.NewZhiMengPDDSDK().
			SelectFunction("getgoods").
			WithArgs(postData).
			Result()
		if err != nil || pddData == nil {
			return nil, ""
		}
		if isList {
			err = pddData.PddToStruct(mdData)
		} else {
			err = pddData.ToStruct(mdData)
		}
		if err != nil {
			//e.OutErr(c, e.ERR_INVALID_ARGS, err)
			return nil, ""
		}
	}

	if mdData != nil && (mdData.GID == goodsId || goodsId == "") {
		r := &md.ProductDetailResponse{}
		r.GoodID = mdData.GoodsSign
		return r, md.PVD_PDD
	}

	return nil, ""
}
func VIPByGoodsID(eg *xorm.Engine, officialEg *xorm.Engine, tmp map[string]string, goodsId, url string, mdData *md.MoreDetailResponse) (*md.ProductDetailResponse, string) {
	postData := make(map[string]interface{})
	union, _ := db.SysUnionByPVDByUse(eg, tmp["master_id"], "vip")
	if zhios_third_party_utils.StrToInt(goodsId) > 0 {
		postData["gid"] = goodsId
	} else {
		postData1 := make(map[string]interface{})
		postData1["url"] = url
		postData["appkey"] = db.SysCfgGetWithDb(eg, tmp["master_id"], md.KEY_CFG_ZM_AK)
		postData["secret_key"] = db.SysCfgGetWithDb(eg, tmp["master_id"], md.KEY_CFG_ZM_SK)

		if union != nil {
			if union.AuthType == 2 {
				uid := zhios_third_party_utils.StrToInt(tmp["uid"])
				postData["pid"] = zhimeng.GetWphPid(uid, "self", tmp["master_id"])
				postData["openId"] = postData["pid"]
			}
			postData["union_type"] = zhios_third_party_utils.IntToStr(union.AuthType)
		}
		if postData["union_type"] == "2" {
			gid := zhimeng.OwnWphParseUrl(union, url)
			postData["gid"] = gid
		} else {
			//改
			vipData1, err1 := vip.NewZhiMengVIPSDK().
				SelectFunction("parse_url").
				WithArgs(postData1).
				Result()
			if err1 != nil || vipData1 == nil {
				//e.OutErr(c, e.ERR_API_RESPONSE, e.NewErr(400, "商品已下架"))
				return nil, ""
			}
			stringInterface := vipData1.VipToMapStringInterface()
			postData["gid"] = stringInterface["gid"]
		}
	}
	postData["appkey"] = db.SysCfgGetWithDb(eg, tmp["master_id"], md.KEY_CFG_ZM_AK)
	postData["secret_key"] = db.SysCfgGetWithDb(eg, tmp["master_id"], md.KEY_CFG_ZM_SK)
	postData["realCall"] = "1"
	postData["openId"] = "default_open_id"
	postData["pid"] = "default_pid"
	if tmp["acc_vip_self_id"] != "" {
		postData["openId"] = strings.ReplaceAll(tmp["acc_vip_self_id"], "self_", "")
		postData["pid"] = tmp["acc_vip_self_id"]
	}
	if union != nil {
		if union.AuthType == 2 {
			uid := zhios_third_party_utils.StrToInt(tmp["uid"])
			postData["pid"] = zhimeng.GetWphPid(uid, "self", tmp["master_id"])
			postData["openId"] = postData["pid"]
		}
		postData["union_type"] = zhios_third_party_utils.IntToStr(union.AuthType)
	}
	if postData["union_type"] == "2" {
		slist := zhimeng.OwnWphDetail(union, postData)
		err := zhimeng.OwnPddToStruct(slist, mdData)
		if err != nil {
			return nil, ""
		}
	} else {
		//改
		vipData, err := vip.NewZhiMengVIPSDK().
			SelectFunction("goods_info").
			WithArgs(postData).
			Result()
		if err != nil || vipData == nil {
			//e.OutErr(c, e.ERR_API_RESPONSE, e.NewErr(400, "商品已下架"))
			return nil, ""
		}
		// to struct
		err = vipData.ToObject().ToStruct(mdData)
		if err != nil {
			//e.OutErr(c, e.ERR_INVALID_ARGS, err)
			return nil, ""
		}
	}
	if mdData != nil {
		// to response
		r := &md.ProductDetailResponse{}
		r.GoodID = mdData.GID
		return r, md.PVD_VIP
	}
	return nil, ""
}

func OfficialRecommendUrl(eg *xorm.Engine, tmp map[string]string, sourceType string, isShare int, isWxMini int, lat float64, lng float64, ActivityId, linkType string, isShowMiniUrl int, activityPlatformUrl string) (*md.OfficialRecommendUrl, error) {
	var (
		err                error
		urls               *md.OfficialRecommendUrl
		activityPlatformId string
		MaterialId         string
	)
	urls = new(md.OfficialRecommendUrl)
	if strings.Contains(sourceType, "_new") {
		sourceType = strings.Replace(sourceType, "_new", "", -1)
	}

	switch sourceType {

	case "tik_tok":
		needQrCode := "0"
		pid := "cloud_" + tmp["uid"] + "_" + tmp["master_id"]
		activityId := "3"
		if activityPlatformId == "1" {
			activityId = "1"
			activityPlatformId = ""
		}
		if activityPlatformId == "2" {
			activityId = "2"
			activityPlatformId = ""
		}
		if isWxMini == 2 {
			needQrCode = "1"
		}
		tikTokArgs := map[string]interface{}{
			"appkey":          db.SysCfgGetWithDb(eg, tmp["master_id"], md.KEY_CFG_ZM_AK),
			"secret_key":      db.SysCfgGetWithDb(eg, tmp["master_id"], md.KEY_CFG_ZM_SK),
			"activity_id":     activityId,
			"mix_activity_id": activityPlatformId,
			"need_qr_code":    needQrCode,
			"external_info":   pid,
			"material_id":     "",
		}

		tikTokBase, _ := tik_tok.Base(eg, tmp["master_id"], "")
		if tikTokBase.AuthSubjectType == "DouKe" {
			tikTokArgs["material_id"] = MaterialId
		}
		key := fmt.Sprintf("%s_tikTokNew_%s_%d_%s_%d_%s_%s_%s_%s_%s", tmp["master_id"], sourceType, isWxMini, needQrCode, isShare, ActivityId, pid, activityPlatformId, tikTokBase.AuthType, MaterialId)
		err1 := cache.GetJson(key, urls)
		var actUrls *md.ConvertedUrls
		if err1 != nil || urls == nil {
			if zhios_third_party_utils.InArr(tikTokBase.AuthType, []string{"2", "3"}) {
				actUrls, err = tik_tok.OwnTikTokActUrl(tikTokBase, tikTokArgs)
				if actUrls != nil {
					urls = &md.OfficialRecommendUrl{
						Url:         actUrls.AppURL,
						WxQrcodeUrl: actUrls.QrcodeUrl,
						TaobaoWord:  actUrls.Content,
					}
				}
			} else {
				tikTokArgs["material_id"] = MaterialId
				actUrls, _ = zhimeng.TikTokActUrl(tikTokArgs)
				if actUrls != nil {
					urls = &md.OfficialRecommendUrl{
						Url:         actUrls.AppURL,
						WxQrcodeUrl: actUrls.QrcodeUrl,
						TaobaoWord:  actUrls.Content,
					}
				}
			}
			if urls != nil && urls.Url != "" {
				cache.SetJson(key, urls, 300)
			}
		}
	case "jd":

		pid := tmp["acc_jd_share_id"]

		var jdUrl *md.ConvertedUrls

		jdUrl, _ = cps_jd.JdUrl(eg, tmp["master_id"], tmp["uid"], "3",
			db.SysCfgGetWithDb(eg, tmp["master_id"], md.KEY_CFG_ZM_AK),
			db.SysCfgGetWithDb(eg, tmp["master_id"], md.KEY_CFG_ZM_SK),
			"",
			pid,
			"",
			"",
			activityPlatformUrl)
		if jdUrl != nil {
			urls.Url = jdUrl.URL
			urls.ClickUrl = jdUrl.ClickUrl
			urls.WxMiniprogramPath = jdUrl.WeChatMiniURL
			urls.Appid = jdUrl.WeChatMiniAPPID
		}

	case "pdd":
		pid := tmp["acc_pdd_self_id"]

		masterPid := pid
		pddPidData, _ := pdd.NewZhiMengPDDSDK().
			SelectFunction("get_pid_list").
			WithArgs(map[string]interface{}{
				"appkey":     db.SysCfgGetWithDb(eg, tmp["master_id"], md.KEY_CFG_ZM_AK),
				"secret_key": db.SysCfgGetWithDb(eg, tmp["master_id"], md.KEY_CFG_ZM_SK),
				"pid":        masterPid},
			).Result()
		if pddPidData != nil {
			b, _ := json.Marshal(pddPidData.ToInterface())
			pddPid := gjson.GetBytes(b, "pdd_pid").String()
			if pddPid == "" {
				profile, _ := db.UserProfileFindByID(eg, 0)
				if profile != nil {
					masterPid = profile.AccPddSelfId
				}
			}
		} else {
			profile, _ := db.UserProfileFindByID(eg, 0)
			if profile != nil {
				masterPid = profile.AccPddSelfId
			}
		}
		var pddUrl *md.ConvertedUrls
		var resourceType = "39998"
		if activityPlatformId != "" {
			ActivityId = activityPlatformId
		}
		//如果是act_ 就是其他活动
		if strings.Contains(ActivityId, "act_") {
			resourceType = strings.ReplaceAll(ActivityId, "act_", "")
			activityPlatformUrl = ""
		}
		if strings.Contains(ActivityId, "store_") { //商城的
			resourceType = strings.ReplaceAll(ActivityId, "store_", "")
			activityPlatformUrl = ""
			pddUrl, _ = zhimeng.PDDActivityStoreConvertUrl(
				db.SysCfgGetWithDb(eg, tmp["master_id"], md.KEY_CFG_ZM_AK),
				db.SysCfgGetWithDb(eg, tmp["master_id"], md.KEY_CFG_ZM_SK),
				resourceType,
				masterPid,
				pid,
				activityPlatformUrl, isShare)
		} else if strings.Contains(ActivityId, "sale_") { //营销
			resourceType = strings.ReplaceAll(ActivityId, "sale_", "")
			activityPlatformUrl = ""
			pddUrl, _ = zhimeng.PDDActivitySaleConvertUrl(
				db.SysCfgGetWithDb(eg, tmp["master_id"], md.KEY_CFG_ZM_AK),
				db.SysCfgGetWithDb(eg, tmp["master_id"], md.KEY_CFG_ZM_SK),
				resourceType,
				masterPid,
				pid,
				activityPlatformUrl, isShare)
		} else {
			pddUrl, _ = zhimeng.PDDActivityConvertUrl(
				db.SysCfgGetWithDb(eg, tmp["master_id"], md.KEY_CFG_ZM_AK),
				db.SysCfgGetWithDb(eg, tmp["master_id"], md.KEY_CFG_ZM_SK),
				resourceType,
				masterPid,
				pid,
				activityPlatformUrl, isShare)
		}

		if pddUrl != nil {
			urls.Url = pddUrl.URL
			urls.WxMiniprogramPath = pddUrl.WeChatMiniURL
			urls.Appid = pddUrl.WeChatMiniAPPID
		}

	default:
		return urls, errors.New("失败")
	}
	return urls, err
}
