package cinema_5bms

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/comm"
	zhios_third_party_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/utils"
	"fmt"
	"github.com/syyongx/php2go"
	"strings"
	"time"
)

func SendPost(method string, signSecret string, param map[string]string) (string, error) {
	url := "https://www.5bms.com/" + method
	param["time"] = zhios_third_party_utils.Int64ToStr(time.Now().Unix())
	param["sign"] = GetSign(param, signSecret)
	for k, v := range param {
		if strings.Contains(url, "?") {
			url += "&" + k + "=" + php2go.URLEncode(v)
		} else {
			url += "?" + k + "=" + php2go.URLEncode(v)
		}
	}
	get, err := zhios_third_party_utils.CurlPost(url, param, nil)
	fmt.Println(string(get))
	fmt.Println(err)
	return string(get), err
}
func GetSign(param map[string]string, signSecret string) string {
	str := ""
	keys := comm.KsortToStr(param)
	for _, k := range keys {
		if str != "" {
			str += "&" + k + "=" + param[k]
		} else {
			str += k + "=" + param[k]
		}
	}
	str += "&app-secret=" + signSecret
	return strings.ToUpper(php2go.Md5(str))
}
