package db

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/db/model"
	"xorm.io/xorm"
)

func IsExistRelationPid(eg *xorm.Engine, uid, union_id int) *model.TaobaoRelationPid {
	var data model.TaobaoRelationPid
	exist, err := eg.Where("uid=? and union_id=?", uid, union_id).Get(&data)
	if exist == false || err != nil {
		return nil
	}
	return &data
}

func GetRelation(eg *xorm.Engine, unionId, count int) (string, int64) {
	var data model.TaobaoRelation
	get, err := eg.Where("union_id=? and count<?", unionId, count).OrderBy("id asc").Get(&data)
	if get == false || err != nil {
		return "", 0
	}
	return data.RelationId, data.Id
}

func GetRelationPid(eg *xorm.Engine, unionId int, pid []string, relationId string) *[]model.TaobaoRelationPid {
	var data []model.TaobaoRelationPid
	err := eg.In("pid", pid).Where("union_id=? and relation_id=?", unionId, relationId).OrderBy("id asc").Find(&data)
	if err != nil {
		return nil
	}
	return &data
}

// 批量订单id查找订单
func TaobaoRelationListByTaobaoIds(Db *xorm.Engine, unionId int, ids []int64) (*[]model.TaobaoRelation, error) {
	var o []model.TaobaoRelation
	if err := Db.In("relation_id", ids).Where("union_id=?", unionId).Find(&o); err != nil {
		return nil, err
	}
	return &o, nil
}
func TaobaoRelationListInsert(Db *xorm.Engine, m *model.TaobaoRelation) bool {
	_, err := Db.InsertOne(m)
	if err != nil {
		return false
	}
	return true
}
func TaobaoRelationOrderUserByTbPids(eg *xorm.Engine, relationId, pid string, unionId int) *model.TaobaoRelationPid {
	var m model.TaobaoRelationPid
	get, err := eg.Where("relation_id=? and short_pid=? and union_id=?", relationId, pid, unionId).Get(&m)
	if get == false || err != nil {
		return nil
	}
	return &m
}
