package model

import (
	"time"
)

type SysUnionSet struct {
	Id           int       `json:"id" xorm:"not null pk autoincr INT(11)"`
	Provider     string    `json:"provider" xorm:"not null default '' comment('联盟类型；taobao：淘宝；jd：京东；pdd：多多(拼多多)；vip：唯品会；suning：苏宁；kaola：考拉；duomai：多麦') VARCHAR(32)"`
	Name         string    `json:"name" xorm:"not null default '' comment('备注名') VARCHAR(32)"`
	ChannelList  string    `json:"channel_list" xorm:"not null default '["share","weixin","android","ios"]' comment('渠道开关；share：分享；weixin：微信；android：安卓；ios：ios') VARCHAR(64)"`
	AuthType     int       `json:"auth_type" xorm:"not null default 1 comment('授权模式；1：跟随官方；2：自有联盟账号') TINYINT(1)"`
	LiveAuthType int       `json:"live_auth_type" xorm:"not null default 1 comment('授权模式；1：跟随官方；2：自有联盟账号') TINYINT(1)"`
	PromoteShare string    `json:"promote_share" xorm:"not null default '' comment('分享推广位') VARCHAR(128)"`
	SelfShare    string    `json:"self_share" xorm:"not null default '' comment('自购推广位') VARCHAR(128)"`
	KeyData      string    `json:"key_data" xorm:"comment('联盟key的值') TEXT"`
	IsUse        int       `json:"is_use" xorm:"default 0 comment('是否启用；0否；1是') TINYINT(3)"`
	AuthStatus   int       `json:"auth_status" xorm:"default 0 comment('授权状态；0：未授权；1：已授权') TINYINT(1)"`
	AuthTime     time.Time `json:"auth_time" xorm:"comment('授权时间') TIMESTAMP"`
	SyncTime     time.Time `json:"sync_time" xorm:"comment('订单同步时间') TIMESTAMP"`
	ExpireTime   time.Time `json:"expire_time" xorm:"TIMESTAMP"`
	CreateAt     time.Time `json:"create_at" xorm:"not null default CURRENT_TIMESTAMP TIMESTAMP"`
	UpdateAt     time.Time `json:"update_at" xorm:"not null default CURRENT_TIMESTAMP TIMESTAMP"`
	IsDelete     int       `json:"is_delete" xorm:"not null default 0 TINYINT(1)"`
	AppletIsAuth int       `json:"applet_is_auth" xorm:"not null default 0 TINYINT(1)"`
	AppletPid    string    `json:"applet_pid" xorm:"not null  comment('') TEXT"`
}
