package jd

// 1-好券商品,2-精选卖场,10-9.9包邮,15-京东配送,22-实时热销榜,23-为你推荐,24-数码家电,25-超市,26-母婴玩具,27-家具日用,28-美妆穿搭,29-医药保健,30-图书文具,31-今日必推,32-京东好物,33-京东秒杀,34-拼购商品,40-高收益榜,41-自营热卖榜,109-新品首发,110-自营,112-京东爆品,125-首购商品,129-高佣榜单,130-视频商品,153-历史最低价商品榜
// 排序字段(price：单价, commissionShare：佣金比例, commission：佣金， inOrderCount30DaysSku：sku维度30天引单量，comments：评论数，goodComments：好评数)
//RequestJD is 请求 京东sdk的参数
type RequestJD struct {
	PageIndex  int    `json:"page_index"`
	PageSize   int    `json:"page_size"`
	EliteID    int    `json:"elite_id"`
	SortName   string `json:"sort_name"`
	UserIDType int    `json:"userid_type"`
	UserID     string `json:"user_id"`
}

// JDFeaturedResponse is return from  taoke.jd
type JDFeaturedResponse struct {
	JdUnionOpenGoodsJingfenQueryResponse struct {
		Code   string `json:"code"`
		Result string `json:"result"`
	} `json:"jd_union_open_goods_jingfen_query_response"`
}

// JDFeature is jd 精选 for微信
type JDFeature struct {
	BrandCode    string `json:"brandCode"`
	BrandName    string `json:"brandName"`
	CategoryInfo struct {
		Cid1     int    `json:"cid1"`
		Cid1Name string `json:"cid1Name"`
		Cid2     int    `json:"cid2"`
		Cid2Name string `json:"cid2Name"`
		Cid3     int    `json:"cid3"`
		Cid3Name string `json:"cid3Name"`
	} `json:"categoryInfo"`
	Comments       int `json:"comments"`
	CommissionInfo struct {
		Commission          float64 `json:"commission"`
		CommissionShare     float64 `json:"commissionShare"`
		CouponCommission    float64 `json:"couponCommission"`
		PlusCommissionShare float64 `json:"plusCommissionShare"`
	} `json:"commissionInfo"`
	CouponInfo struct {
		CouponList []struct {
			BindType     int     `json:"bindType"`
			Discount     float64 `json:"discount"`
			GetEndTime   int64   `json:"getEndTime"`
			GetStartTime int64   `json:"getStartTime"`
			HotValue     int     `json:"hotValue"`
			IsBest       int     `json:"isBest"`
			Link         string  `json:"link"`
			PlatformType int     `json:"platformType"`
			Quota        float64 `json:"quota"`
			UseEndTime   int64   `json:"useEndTime"`
			UseStartTime int64   `json:"useStartTime"`
		} `json:"couponList"`
	} `json:"couponInfo"`
	GoodCommentsShare float64 `json:"goodCommentsShare"`
	ImageInfo         struct {
		ImageList []struct {
			URL string `json:"url"`
		} `json:"imageList"`
	} `json:"imageInfo"`
	InOrderCount30Days    int    `json:"inOrderCount30Days"`
	InOrderCount30DaysSku int    `json:"inOrderCount30DaysSku"`
	IsHot                 int    `json:"isHot"`
	MaterialURL           string `json:"materialUrl"`
	Owner                 string `json:"owner"`
	PinGouInfo            struct {
	} `json:"pinGouInfo"`
	PriceInfo struct {
		LowestCouponPrice float64 `json:"lowestCouponPrice"`
		LowestPrice       float64 `json:"lowestPrice"`
		LowestPriceType   int     `json:"lowestPriceType"`
		Price             float64 `json:"price"`
	} `json:"priceInfo"`
	ResourceInfo struct {
		EliteID   int    `json:"eliteId"`
		EliteName string `json:"eliteName"`
	} `json:"resourceInfo"`
	ShopInfo struct {
		ShopID    int     `json:"shopId"`
		ShopLevel float64 `json:"shopLevel"`
		ShopName  string  `json:"shopName"`
	} `json:"shopInfo"`
	SkuID   int64  `json:"skuId"`
	SkuName string `json:"skuName"`
	Spuid   int64  `json:"spuid"`
}
