package cps_jd

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/db"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/jd"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/jd_union"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/md"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/md/cps_jd"
	zhios_third_party_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/utils"
	"encoding/json"
	"errors"
	"github.com/syyongx/php2go"
	"github.com/tidwall/gjson"
	"strings"
	"time"
	"xorm.io/xorm"
)

func JdUnionComm() map[string]string {
	keyArr := map[string]string{
		"app_key":      "444ab671c4d095122916453d09af27fc",
		"access_token": "",
		"app_secret":   "aef3c2745cc44194816d0c89c65b3847",
	}
	return keyArr
}
func JdDetailGoods(eg *xorm.Engine, dbName string, postData map[string]interface{}) (*md.MoreDetailResponse, error) {
	auth, _ := db.SysUnionByJdByUseByAuth(eg, dbName)
	if auth != nil {
		postData["union_type"] = zhios_third_party_utils.IntToStr(auth.AuthType)
	}
	var r md.MoreDetailResponse
	if postData["union_type"] == "2" {
		param := map[string]interface{}{}
		if php2go.IsNumeric(postData["gid"]) {
			param["skuIds"] = []string{zhios_third_party_utils.AnyToString(postData["gid"])}
		} else {
			param["itemIds"] = []string{zhios_third_party_utils.AnyToString(postData["gid"])}
		}
		keyArr := JdUnionComm()

		goods, err := jd_union.SearchGoods(keyArr, param)
		if err != nil {
			return nil, err
		}
		resp := gjson.Get(goods, "jd_union_open_goods_query_responce.queryResult").String()
		var data cps_jd.JdSearchGoods
		err = json.Unmarshal([]byte(resp), &data)
		if err != nil {
			return nil, err
		}
		if len(data.Data) == 0 {
			return nil, errors.New("商品已下架")
		}
		var tmpData md.MoreDetailResponse
		for _, v := range data.Data {
			imgList := make([]string, 0)
			img := ""
			for k1, v1 := range v.ImageInfo.ImageList {
				imgList = append(imgList, v1.Url)
				if k1 == 0 {
					img = v1.Url
				}
			}
			var tmp = md.MoreDetailResponse{
				CommissionRate:    zhios_third_party_utils.Float64ToStr(v.CommissionInfo.CommissionShare),
				CouponURL:         "",
				CouponPrice:       "",
				EndTime:           zhios_third_party_utils.IntToStr(int(time.Now().Unix()) + 86400*365),
				GID:               v.ItemId,
				GoodsImg:          img,
				GoodsTitle:        strings.ReplaceAll(v.SkuName, "\t", ""),
				InOrderCount:      zhios_third_party_utils.IntToStr(v.InOrderCount30Days),
				LowerPrice:        zhios_third_party_utils.Float64ToStr(v.PriceInfo.LowestPrice),
				LowerPriceType:    zhios_third_party_utils.IntToStr(v.PriceInfo.LowestPriceType),
				LowestCouponPrice: zhios_third_party_utils.Float64ToStr(v.PriceInfo.LowestCouponPrice),
				ShopID:            zhios_third_party_utils.IntToStr(v.ShopInfo.ShopId),
				ShopName:          v.ShopInfo.ShopName,
				StartTime:         zhios_third_party_utils.Int64ToStr(time.Now().Unix()),
				StoreID:           "0",
				WlGoodsPrice:      zhios_third_party_utils.Float64ToStr(v.PriceInfo.Price),

				GoodsImgList:  imgList,
				ImageList:     imgList,
				DetailImgList: imgList,
			}
			if zhios_third_party_utils.StrToFloat64(tmp.LowerPrice) > 0 {
				tmp.WlGoodsPrice = tmp.LowerPrice
			}
			if len(v.CouponInfo.CouponList) > 0 {
				var max float64 = 0
				for _, v1 := range v.CouponInfo.CouponList {
					if v1.Discount > max && v1.IsBest == 1 {
						tmp.CouponPrice = zhios_third_party_utils.Float64ToStr(v1.Discount)
						tmp.CouponURL = v1.Link
						max = v1.Discount
					}
				}
			}
			tmpData = tmp
		}
		r = tmpData
	} else {
		jdData, err := jd.NewZhiMengJingDongSDK().
			SelectFunction("getgoodsinfo").
			WithArgs(postData).
			Result()
		if err != nil {
			return nil, errors.New("商品下架")
		}
		// to struct
		err = jdData.ToStruct(&r)
		if err != nil {
			return nil, err
		}
	}

	return &r, nil
}
