package cps_jd

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/db"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/jd"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/jd_union"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/md"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/md/cps_jd"
	zhios_third_party_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/utils"
	"encoding/json"
	"errors"
	"github.com/jinzhu/copier"
	"github.com/tidwall/gjson"
	"strings"
	"time"
	"xorm.io/xorm"
)

func JdSearchGoodsUrl(eg *xorm.Engine, dbName string, postData map[string]interface{}) (*md.MoreDetailResponse, error) {
	auth, _ := db.SysUnionByJdByUseByAuth(eg, dbName)
	if auth != nil {
		postData["union_type"] = zhios_third_party_utils.IntToStr(auth.AuthType)
	}
	var r md.MoreDetailResponse
	if postData["union_type"] == "2" {
		param := map[string]interface{}{
			"pageIndex": postData["p"],
			"pageSize":  postData["size"],
			"keyword":   postData["keyword"],
		}
		keyArr := JdUnionComm()
		goods, err := jd_union.SearchGoods(keyArr, param)
		if err != nil {
			return nil, err
		}
		resp := gjson.Get(goods, "jd_union_open_goods_query_responce.queryResult").String()
		var data cps_jd.JdSearchGoods
		err = json.Unmarshal([]byte(resp), &data)
		if err != nil {
			return nil, err
		}
		if len(data.Data) == 0 || len(data.Data) > 1 {
			return nil, nil
		}
		var tmpData md.JDZhimengItem
		for _, v := range data.Data {
			imgList := make([]string, 0)
			img := ""
			for k1, v1 := range v.ImageInfo.ImageList {
				imgList = append(imgList, v1.Url)
				if k1 == 0 {
					img = v1.Url
				}
			}
			var tmp = md.JDZhimengItem{
				Cid1:              v.CategoryInfo.Cid1,
				Cid1Name:          v.CategoryInfo.Cid1Name,
				Cid2:              v.CategoryInfo.Cid2,
				Cid2Name:          v.CategoryInfo.Cid2Name,
				Cid3:              v.CategoryInfo.Cid3,
				Cid3Name:          v.CategoryInfo.Cid3Name,
				CommissionRate:    v.CommissionInfo.CommissionShare,
				CouponURL:         "",
				EndTime:           int(time.Now().Unix()) + 86400*365,
				Gid:               v.ItemId,
				GoodsImg:          img,
				GoodsTitle:        strings.ReplaceAll(v.SkuName, "\t", ""),
				ImgList:           imgList,
				InOrderCount:      v.InOrderCount30Days,
				IsFreeFreightRisk: 1,
				IsFreeShipping:    1,
				IsJdSale:          v.IsJdSale,
				LowerPrice:        v.PriceInfo.LowestPrice,
				LowerPriceType:    v.PriceInfo.LowestPriceType,
				LowestCouponPrice: v.PriceInfo.LowestCouponPrice,
				PcGoodsPrice:      v.PriceInfo.Price,
				ShopID:            v.ShopInfo.ShopId,
				ShopName:          v.ShopInfo.ShopName,
				StartTime:         int(time.Now().Unix()),
				StoreID:           "0",
				WlGoodsPrice:      v.PriceInfo.Price,
			}
			if tmp.LowerPrice > 0 {
				tmp.PcGoodsPrice = tmp.LowerPrice
				tmp.WlGoodsPrice = tmp.LowerPrice
			}
			if len(v.CouponInfo.CouponList) > 0 {
				var max float64 = 0
				for _, v1 := range v.CouponInfo.CouponList {
					if v1.Discount > max && v1.IsBest == 1 {
						tmp.CouponPrice = int(v1.Discount)
						tmp.CouponURL = v1.Link
						max = v1.Discount
					}
				}
			}
			tmpData = tmp
		}
		copier.Copy(&r, &tmpData)
		return &r, nil
	} else {
		jdData, err := jd.NewZhiMengJingDongSDK().
			SelectFunction("new_getgoods").
			WithArgs(postData).
			Result()
		if jdData == nil {
			return nil, errors.New("商品已下架")
		}
		if err == nil {
			itemInfo := &md.MoreDetailResponse{}
			if err := jdData.ToStruct(itemInfo); err != nil {
				return nil, err
			}
			return itemInfo, nil
		} else {
			return nil, errors.New("商品已下架")
		}
	}
	return nil, nil
}
