package cps_jd

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/db"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/jd_union"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/md"
	zhios_third_party_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/utils"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/zhimeng"
	"errors"
	"github.com/tidwall/gjson"
	"xorm.io/xorm"
)

func JdUrl(eg *xorm.Engine, dbName string, uid string, buyType string, appkey, appsecret, itemId, promoId, couponUrl, couponPrice, activityUrl string) (*md.ConvertedUrls, error) {
	auth, _ := db.SysUnionByJdByUseByAuth(eg, dbName)
	var urls *md.ConvertedUrls
	var err error
	unionType := 0
	if auth != nil {
		unionType = auth.AuthType
	}
	if unionType == 2 {
		url := itemId
		if activityUrl != "" {
			url = activityUrl
		}
		req := map[string]interface{}{
			"materialId": url,
			"unionId":    gjson.Get(auth.KeyData, "apiAppId").String(),
			"positionId": uid + "0" + dbName + "0" + buyType,
			"chainType":  "3",
		}
		if couponUrl != "" {
			req["couponUrl"] = couponUrl
		}
		urls, err = JdUnionUrl(req)
		if urls != nil {
			urls.HasCoupon = false
			if couponUrl != "" {
				urls.HasCoupon = true
			}
			urls.CommissionRate = couponPrice
			urls.ItemId = itemId
		}
	} else {
		urls, err = zhimeng.JDConvertUrl(
			appkey,
			appsecret,
			itemId,
			promoId,
			couponUrl,
			couponPrice,
			activityUrl)
	}

	return urls, err
}
func JdUnionUrl(goodsReq map[string]interface{}) (*md.ConvertedUrls, error) {
	param := map[string]interface{}{
		"promotionCodeReq": goodsReq,
	}
	keyArr := JdUnionComm()
	paramJson := zhios_third_party_utils.SerializeStr(param)
	send, err := jd_union.SendGet(keyArr, "jd.union.open.promotion.byunionid.get", paramJson, "1.0")
	var urls md.ConvertedUrls
	if err != nil {
		return nil, err
	}
	if send == "" {
		return nil, errors.New("转链失败")
	}
	resp := gjson.Get(send, "jd_union_open_promotion_byunionid_get_responce.getResult").String()
	code := gjson.Get(resp, "code").Int()
	if code != 200 {
		return nil, errors.New(gjson.Get(resp, "message").String())
	}
	urls = md.ConvertedUrls{
		URL:          gjson.Get(resp, "data.shortURL").String(),
		ShortenURL:   gjson.Get(resp, "data.shortURL").String(),
		NoOpenAppURL: gjson.Get(resp, "data.shortURL").String(),
		AppURL:       gjson.Get(resp, "data.shortURL").String(),
		ClickUrl:     gjson.Get(resp, "data.url").String(),
	}
	return &urls, nil
}
