package cps_jd

type JdSearchGoods struct {
	Code int `json:"code"`
	Data []struct {
		BrandCode    string `json:"brandCode"`
		BrandName    string `json:"brandName"`
		CategoryInfo struct {
			Cid1     int    `json:"cid1"`
			Cid1Name string `json:"cid1Name"`
			Cid2     int    `json:"cid2"`
			Cid2Name string `json:"cid2Name"`
			Cid3     int    `json:"cid3"`
			Cid3Name string `json:"cid3Name"`
		} `json:"categoryInfo"`
		Comments       int `json:"comments"`
		CommissionInfo struct {
			Commission          float64 `json:"commission"`
			CommissionShare     float64 `json:"commissionShare"`
			CouponCommission    float64 `json:"couponCommission"`
			EndTime             int64   `json:"endTime"`
			IsLock              int     `json:"isLock"`
			PlusCommissionShare float64 `json:"plusCommissionShare"`
			StartTime           int64   `json:"startTime"`
		} `json:"commissionInfo"`
		CouponInfo struct {
			CouponList []struct {
				BindType      int     `json:"bindType"`
				CouponStyle   int     `json:"couponStyle"`
				Discount      float64 `json:"discount"`
				GetEndTime    int64   `json:"getEndTime"`
				GetStartTime  int64   `json:"getStartTime"`
				IsBest        int     `json:"isBest"`
				IsInputCoupon int     `json:"isInputCoupon"`
				Link          string  `json:"link"`
				PlatformType  int     `json:"platformType"`
				Quota         float64 `json:"quota"`
				UseEndTime    int64   `json:"useEndTime"`
				UseStartTime  int64   `json:"useStartTime"`
				HotValue      int     `json:"hotValue,omitempty"`
			} `json:"couponList"`
		} `json:"couponInfo"`
		DeliveryType      int     `json:"deliveryType"`
		EliteType         []int   `json:"eliteType,omitempty"`
		ForbidTypes       []int   `json:"forbidTypes"`
		GoodCommentsShare float64 `json:"goodCommentsShare"`
		ImageInfo         struct {
			ImageList []struct {
				Url string `json:"url"`
			} `json:"imageList"`
			WhiteImage string `json:"whiteImage,omitempty"`
		} `json:"imageInfo"`
		InOrderComm30Days  float64 `json:"inOrderComm30Days"`
		InOrderCount30Days int     `json:"inOrderCount30Days"`
		IsHot              int     `json:"isHot"`
		IsJdSale           int     `json:"isJdSale"`
		IsOversea          int     `json:"isOversea"`
		ItemId             string  `json:"itemId"`
		MaterialUrl        string  `json:"materialUrl"`
		Owner              string  `json:"owner"`
		PinGouInfo         struct {
		} `json:"pinGouInfo"`
		PingGouInfo struct {
		} `json:"pingGouInfo"`
		PriceInfo struct {
			HistoryPriceDay   int     `json:"historyPriceDay,omitempty"`
			LowestCouponPrice float64 `json:"lowestCouponPrice"`
			LowestPrice       float64 `json:"lowestPrice"`
			LowestPriceType   int     `json:"lowestPriceType"`
			Price             float64 `json:"price"`
		} `json:"priceInfo"`
		ShopInfo struct {
			AfsFactorScoreRankGrade       string  `json:"afsFactorScoreRankGrade,omitempty"`
			AfterServiceScore             string  `json:"afterServiceScore,omitempty"`
			CommentFactorScoreRankGrade   string  `json:"commentFactorScoreRankGrade,omitempty"`
			LogisticsFactorScoreRankGrade string  `json:"logisticsFactorScoreRankGrade,omitempty"`
			LogisticsLvyueScore           string  `json:"logisticsLvyueScore,omitempty"`
			ScoreRankRate                 string  `json:"scoreRankRate,omitempty"`
			ShopId                        int     `json:"shopId"`
			ShopLabel                     string  `json:"shopLabel"`
			ShopLevel                     float64 `json:"shopLevel"`
			ShopName                      string  `json:"shopName"`
			UserEvaluateScore             string  `json:"userEvaluateScore,omitempty"`
		} `json:"shopInfo"`
		SkuId     int64  `json:"skuId"`
		SkuName   string `json:"skuName"`
		Spuid     int64  `json:"spuid"`
		VideoInfo struct {
			VideoList []struct {
				Duration  int    `json:"duration"`
				High      int    `json:"high"`
				ImageUrl  string `json:"imageUrl"`
				PlayType  string `json:"playType"`
				PlayUrl   string `json:"playUrl"`
				VideoType int    `json:"videoType"`
				Width     int    `json:"width"`
			} `json:"videoList,omitempty"`
		} `json:"videoInfo"`
		JxFlags             []int `json:"jxFlags,omitempty"`
		SecondPriceInfoList []struct {
			SecondPrice     float64 `json:"secondPrice"`
			SecondPriceType int     `json:"secondPriceType"`
		} `json:"secondPriceInfoList,omitempty"`
	} `json:"data"`
	Message    string `json:"message"`
	RequestId  string `json:"requestId"`
	TotalCount int    `json:"totalCount"`
}
