package csjp

type CsjpOrder struct {
	OrderId    string `json:"order_id"`
	Status     int    `json:"status"`
	PayAmount  int    `json:"pay_amount"`
	PayTime    int    `json:"pay_time"`
	UpdateTime int    `json:"update_time"`
	PoiInfo    struct {
		Name  string `json:"name"`
		PoiId int64  `json:"poi_id"`
	} `json:"poi_info"`
	RefundAmount int    `json:"refund_amount"`
	RootOrderId  string `json:"root_order_id"`
	ProductList  []struct {
		ProductId int64  `json:"product_id"`
		SkuId     int64  `json:"sku_id"`
		Name      string `json:"name"`
		Count     int    `json:"count"`
		Img       string `json:"img"`
	} `json:"product_list"`
	SettleOrders        interface{} `json:"settle_orders"`
	MediaId             int         `json:"media_id"`
	AppId               int         `json:"app_id"`
	Pid                 string      `json:"pid"`
	CommandExternalInfo string      `json:"command_external_info"`
	CommissionRate      int         `json:"commission_rate"`
	CommissionAmount    int         `json:"commission_amount"`
	SettleFinish        bool        `json:"settle_finish"`
	SettleAmount        int         `json:"settle_amount"`
}
type CsjpProductList struct {
	Id         int64  `json:"id"`
	Name       string `json:"name"`
	Type       int    `json:"type"`
	ProductImg struct {
		UrlList []string `json:"url_list"`
	} `json:"product_img"`
	ProductItemDetail []struct {
		Title    string `json:"title"`
		ItemList []struct {
			Name  string `json:"name"`
			Price int    `json:"price"`
			Count int    `json:"count"`
			Unit  string `json:"unit"`
		} `json:"item_list"`
	} `json:"product_item_detail,omitempty"`
	SaleTags      []string `json:"sale_tags"`
	Price         int      `json:"price"`
	OriginPrice   int      `json:"origin_price"`
	MarketingInfo struct {
		SeckillInfo struct {
			Status         int `json:"status"`
			StartTime      int `json:"start_time"`
			EndTime        int `json:"end_time"`
			DiscountAmount int `json:"discount_amount"`
		} `json:"seckill_info,omitempty"`
	} `json:"marketing_info"`
	BlurredSoldCount string `json:"blurred_sold_count"`
	SellOut          bool   `json:"sell_out"`
	FirstCategory    struct {
		Id   int    `json:"id"`
		Name string `json:"name"`
	} `json:"first_category"`
	SecondCategory struct {
		Id   int    `json:"id"`
		Name string `json:"name"`
	} `json:"second_category"`
	ThirdCategory struct {
		Id   int    `json:"id"`
		Name string `json:"name"`
	} `json:"third_category"`
	SoldTimeBegin int `json:"sold_time_begin"`
	SoldTimeEnd   int `json:"sold_time_end"`
	NearestPoi    struct {
		Name     string  `json:"name"`
		Distance float64 `json:"distance"`
	} `json:"nearest_poi"`
	PoiCount         int    `json:"poi_count"`
	DyH5Url          string `json:"dy_h5_url"`
	CommissionRate   int    `json:"commission_rate"`
	CommissionAmount int    `json:"commission_amount"`
}
