package md

type KuaishouOrder struct {
	Pcursor   string      `json:"pcursor"`
	OrderView []OrderView `json:"orderView"`
}
type OrderView struct {
	Oid                       int   `json:"oid"`
	ActivityUserId            int   `json:"activityUserId"`
	ActivityId                int   `json:"activityId"`
	CpsOrderStatus            int   `json:"cpsOrderStatus"`
	OrderCreateTime           int64 `json:"orderCreateTime"`
	OrderTradeAmount          int64 `json:"orderTradeAmount"`
	PayAmount                 int   `json:"payAmount"`
	RegimentalPromotionRate   int   `json:"regimentalPromotionRate"`
	RegimentalPromotionAmount int   `json:"regimentalPromotionAmount"`
	CpsOrderProductView       []struct {
		Oid            int64  `json:"oid"`
		ItemId         int64  `json:"itemId"`
		ItemTitle      string `json:"itemTitle"`
		ItemPrice      int64  `json:"itemPrice"`
		SellerId       int64  `json:"sellerId"`
		SellerNickName string `json:"sellerNickName"`
		SkuId          int    `json:"skuId"`
	} `json:"cpsOrderProductView"`
	CreateTime                    int64  `json:"createTime"`
	UpdateTime                    int64  `json:"updateTime"`
	SendTime                      int64  `json:"sendTime"`
	SendStatus                    int    `json:"sendStatus"`
	RecvTime                      int64  `json:"recvTime"`
	PromotionId                   int    `json:"promotionId"`
	PromotionNickName             string `json:"promotionNickName"`
	PromotionType                 int    `json:"promotionType"`
	SettlementAmount              int    `json:"settlementAmount"`
	SettlementTime                int64  `json:"settlementTime"`
	SettlementSuccessTime         int64  `json:"settlementSuccessTime"`
	BuyerOpenId                   string `json:"buyerOpenId"`
	PromotionKwaiId               string `json:"promotionKwaiId"`
	ExpendRegimentalSettleAmount  int    `json:"expendRegimentalSettleAmount"`
	ExpendEstimateSettleAmount    int    `json:"expendEstimateSettleAmount"`
	ExpendRegimentalPromotionRate int    `json:"expendRegimentalPromotionRate"`
	BaseAmount                    int    `json:"baseAmount"`
	ShareRateStr                  string `json:"shareRateStr"`
	ExcitationInCome              int    `json:"excitationInCome"`
	ServiceIncome                 int    `json:"serviceIncome"`
	SettlementBizType             int    `json:"settlementBizType"`
	FundType                      int    `json:"fundType"`
	KwaimoneyUserId               int    `json:"kwaimoneyUserId"`
	KwaimoneyUserNickName         string `json:"kwaimoneyUserNickName"`
}

type KuaishouGoods struct {
	GoodsId          int         `json:"goodsId"`
	GoodsPrice       int         `json:"goodsPrice"`
	GoodsTitle       string      `json:"goodsTitle"`
	GoodsDesc        string      `json:"goodsDesc"`
	MallId           int         `json:"mallId"`
	MallName         string      `json:"mallName"`
	MallType         int         `json:"mallType"`
	GoodsImageUrl    string      `json:"goodsImageUrl"`
	CategoryId       int         `json:"categoryId"`
	PromotionRate    int         `json:"promotionRate"`
	SalesTip         int         `json:"salesTip"`
	GoodsGalleryUrls interface{} `json:"goodsGalleryUrls"`
	PromotionAmount  int         `json:"promotionAmount"`
	ItemDescUrls     interface{} `json:"itemDescUrls"`
	ExpressId        int         `json:"expressId"`
	ZkGoodsPrice     int         `json:"zkGoodsPrice"`
}
type KuaishouCpsOrder struct {
	Oid                          int   `json:"oid"`
	CpsOrderStatus               int   `json:"cpsOrderStatus"`
	OrderCreateTime              int   `json:"orderCreateTime"`
	PayTime                      int   `json:"payTime"`
	OrderTradeAmount             int   `json:"orderTradeAmount"`
	CreateTime                   int64 `json:"createTime"`
	UpdateTime                   int64 `json:"updateTime"`
	SettlementSuccessTime        int64 `json:"settlementSuccessTime"`
	SettlementAmount             int   `json:"settlementAmount"`
	CpsKwaimoneyOrderProductView []struct {
		Oid                 int    `json:"oid"`
		ItemId              int    `json:"itemId"`
		ItemTitle           string `json:"itemTitle"`
		ItemPicUrl          string `json:"itemPicUrl"`
		ItemPrice           int    `json:"itemPrice"`
		SkuDesc             string `json:"skuDesc"`
		EstimatedIncome     int    `json:"estimatedIncome"`
		CommissionRate      int    `json:"commissionRate"`
		PaymentFee          int    `json:"paymentFee"`
		CpsPid              string `json:"cpsPid"`
		SellerId            int    `json:"sellerId"`
		SellerNickname      string `json:"sellerNickname"`
		Num                 int    `json:"num"`
		CpsType             int    `json:"cpsType"`
		DistributorId       int    `json:"distributorId"`
		DistributorNickname string `json:"distributorNickname"`
		Comments            string `json:"comments"`
	} `json:"cpsKwaimoneyOrderProductView"`
	BaseAmount   int    `json:"baseAmount"`
	ShareRateStr string `json:"shareRateStr"`
}
