package md

type TCPrase struct {
	Count          string                 `json:"count"`            //转链内容
	SuccessCount   string                 `json:"success_count"`    //转链内容
	FailCount      string                 `json:"fail_count"`       //转链内容
	GID            string                 `json:"gid"`              //商品id
	GoodsMinImg    string                 `json:"goods_min_img"`    //商品小图片
	GoodsImg       string                 `json:"goods_img"`        //商品图片
	GoodsTitle     string                 `json:"goods_title"`      //商品标题
	Provider       string                 `json:"provider"`         //渠道代码
	ProviderName   string                 `json:"provider_name"`    //渠道名字
	GoodsCostPrice string                 `json:"goods_cost_price"` //原价
	Commission     string                 `json:"commission"`       //反的价钱
	FCommission    string                 `json:"f_commission"`     //反的价钱
	WlGoodsPrice   string                 `json:"wl_goods_price"`   //卷后价
	CouponPrice    string                 `json:"coupon_price"`     //优惠券价
	ShareValue     string                 `json:"share_value"`      //分享赚
	ProductDetail  *ProductDetailResponse `json:"detail_data"`      //商品详情
	TurnChainLink  string                 `json:"turn_chain_link"`  // 转链后的链接
	CommissionRate string                 `json:"commission_rate"`
	Tkl            string                 `json:"tkl"`    // 淘口令
	IsTkl          string                 `json:"is_tkl"` // 淘口令
	DownloadLink   string                 `json:"downloadLink"`
	InviteCode     string                 `json:"invite_code"`
	IsNeedAuth     string                 `json:"is_need_auth"`
	PlatType       string                 `json:"plat_type"`
	TurnGoods      []TurnGoods            `json:"turn_goods"`
}
type TurnGoods struct {
	GID            string                 `json:"gid"`              //商品id
	GoodsMinImg    string                 `json:"goods_min_img"`    //商品小图片
	GoodsImg       string                 `json:"goods_img"`        //商品图片
	GoodsTitle     string                 `json:"goods_title"`      //商品标题
	Provider       string                 `json:"provider"`         //渠道代码
	ProviderName   string                 `json:"provider_name"`    //渠道名字
	GoodsCostPrice string                 `json:"goods_cost_price"` //原价
	Commission     string                 `json:"commission"`       //反的价钱
	FCommission    string                 `json:"f_commission"`     //反的价钱
	WlGoodsPrice   string                 `json:"wl_goods_price"`   //卷后价
	CouponPrice    string                 `json:"coupon_price"`     //优惠券价
	ShareValue     string                 `json:"share_value"`      //分享赚
	ProductDetail  *ProductDetailResponse `json:"detail_data"`      //商品详情
	TurnChainLink  string                 `json:"turn_chain_link"`  // 转链后的链接
	CommissionRate string                 `json:"commission_rate"`
	Tkl            string                 `json:"tkl"`    // 淘口令
	IsTkl          string                 `json:"is_tkl"` // 淘口令
	Url            string                 `json:"url"`
}

type ItemParseInfo struct {
	IsCsjp          string                 `json:"is_csjp"`
	ItemId          string                 `json:"item_id"`         // 商品ID
	Title           string                 `json:"title"`           // 标题
	CategoryId      string                 `json:"category_id"`     // 目录ID
	CategoryName    string                 `json:"category_name"`   // 目录名
	Price           string                 `json:"price"`           // 价格
	PriceOriginal   string                 `json:"price_original"`  // 原价
	Commission      string                 `json:"commission"`      // 可赚取佣金
	CommissionRate  string                 `json:"commission_rate"` // 佣金比例
	CouponUrl       string                 `json:"coupon_url"`      // 优惠券地址
	DetailUrl       string                 `json:"detail_url"`      // 优惠券地址
	APPUrl          string                 `json:"app_url"`         // 唤起app地址
	CouponPrice     float64                `json:"coupon_price"`    // 优惠券面值
	FinalPrice      string                 `json:"final_price"`     // 券后价
	EarnPrice       string                 `json:"earn_price"`      //立省
	Thumbnail       string                 `json:"thumbnail"`       // 缩略图
	Provider        string                 `json:"provider"`        // 供应商
	ProviderName    string                 `json:"providerName"`    // 供应商名称
	GoodsDesc       string                 `json:"goodsDesc"`       //描述
	GoodsImgList    []string               `json:"goodsImgList"`    //商品多组图片
	ImageList       []string               `json:"imgList"`
	Video           []interface{}          `json:"video"`
	InOrderCount    string                 `json:"inOrderCount"`
	DetailImgList   []string               `json:"detailImgList"`
	GoodsSales      string                 `json:"goods_sales"`
	ShopName        string                 `json:"shop_name"`
	Word            string                 `json:"word"`
	Param           ParamData              `json:"param"`
	IsNeedChangeUrl string                 `json:"is_need_change_url"`
	Pvd             string                 `json:"pvd"`
	IsFav           string                 `json:"is_fav"`
	ShareUrlArgs    map[string]interface{} `json:"share_url_args"`
	FavArgs         interface{}            `json:"fav_args"`
	ActivityId      string                 `json:"activity_id"`
	Url             string                 `json:"url"`
	NewProvider     string                 `json:"new_provider"`
}
type ParamData struct {
	GID         string `json:"gid"`
	GoodURL     string `json:"good_url"`
	CouponURL   string `json:"coupon_url"`
	CouponPrice string `json:"coupon_price"`
	ActivityURL string `json:"activity_url"`
	IsShare     string `json:"is_share"`
	IsFree      string `json:"is_free"`
	IsWxMini    string `json:"is_wx_mini"`
	Commission  string `json:"commission"`
}
