package md

// DetailRequest is get the uri args to struct
type DetailRequest struct {
	Provider string `uri:"provider" binding:"required"`
	Gid      string `uri:"gid" binding:"required"`
}

// DetailResponse is Detail response
type DetailResponse struct {
	Provider                                  string             `json:"provider"`
	Title                                     string             `json:"title"`
	TitleColor                                string             `json:"title_color"`
	DownloadAPPIcon                           string             `json:"download_app_icon"`
	DownloadAPPBackgroundColor                string             `json:"download_app_background_color"`
	DownloadAPPMain                           string             `json:"download_app_main"`
	DownloadAPPMainColor                      string             `json:"download_app_main_color"`
	DownloadAPPJump                           string             `json:"download_app_jump"`
	DownloadAPPJumpColor                      string             `json:"download_app_jump_color"`
	DownloadAPPJumpURL                        string             `json:"download_app_jump_url"`
	CurrentPrice                              string             `json:"current_price"`
	CurrentPriceColor                         string             `json:"current_price_color"`
	AfterCouponPrice                          string             `json:"after_coupon_price"`
	AfterCouponPriceColor                     string             `json:"after_coupon_price_color"`
	Point                                     string             `json:"point"`
	PointColor                                string             `json:"point_color"`
	PointBackgroundColor                      string             `json:"point_background_color"`
	SoldCount                                 string             `json:"sold_count"`
	SoldCountColor                            string             `json:"sold_count_color"`
	ProviderName                              string             `json:"provider_name"`
	ProviderNameColor                         string             `json:"provider_name_color"`
	ProviderNameBackgroundColor               string             `json:"provider_name_background_color"`
	ProductName                               string             `json:"product_name"`
	ProductNameColor                          string             `json:"product_name_color"`
	ProductDiscountDescription                string             `json:"product_discount_description"`
	ProductDiscountDescriptionColor           string             `json:"product_discount_description_color"`
	ProductDiscountDescriptionBackgroundColor string             `json:"product_discount_description_background_color"`
	CommissionDescription                     string             `json:"commission_description"`
	CommissionDescriptionColor                string             `json:"commission_description_color"`
	CommissionDescriptionBackgroundColor      string             `json:"commission_description_background_color"`
	CouponAmount                              string             `json:"coupon_amount"`
	CouponTypeText                            string             `json:"coupon_type_text"`
	CouponURL                                 string             `json:"coupon_url"`
	CouponEndTime                             string             `json:"coupon_endtime"`
	CouponColor                               string             `json:"coupon_color"`
	CouponBackground                          string             `json:"coupon_background"`
	ShopName                                  string             `json:"shop_name"`
	ShopIcon                                  string             `json:"shop_icon"`
	ImageList                                 []string           `json:"image_list"`
	ImageDetailList                           []string           `json:"image_detail_list"`
	ButtonIndexIcon                           string             `json:"button_index_icon"`
	ButtonIndexColor                          string             `json:"button_index_color"`
	ButtonFavoriteIcon                        string             `json:"button_favorite_icon"`
	ButtonFavoriteColor                       string             `json:"button_favorite_color"`
	ButtonShare                               string             `json:"button_share"`
	ButtonShareColor                          string             `json:"button_share_color"`
	ButtonShareBackgroundColor                string             `json:"button_share_background_color"`
	ButtonShareBackgroundColor2               string             `json:"button_share_background_color2"`
	ButtonSelfBuy                             string             `json:"button_self_buy"`
	ButtonSelfBuyColor                        string             `json:"button_self_buy_color"`
	ButtonSelfBuyBackgroundColor              string             `json:"button_self_buy_background_color"`
	ButtonSelfBuyBackgroundColor2             string             `json:"button_self_buy_background_color2"`
	MoreDetail                                MoreDetailResponse `json:"more_detail"`
}

// MoreDetailResponse is for response detail
type MoreDetailResponse struct {
	ClickUrl             string        `json:"click_url"`
	GID                  string        `json:"gid"`
	GoodsImg             string        `json:"goods_img"`
	GoodsTitle           string        `json:"goods_title"`
	GoodsCostPrice       string        `json:"goods_cost_price"` //原价
	GoodsDesc            string        `json:"goods_desc"`
	GoodsPrice           string        `json:"goods_price"`
	GoodsMinImg          string        `json:"goods_min_img"`
	GoodsImgList         []string      `json:"goods_img_list"`
	GoodsSales           string        `json:"goods_sales"`
	GoodURL              string        `json:"good_url"`
	GoodMobileURL        string        `json:"good_mobile_url"`
	CID                  string        `json:"cid"`
	CID1                 string        `json:"cid1"`
	CID1Name             string        `json:"cid1_name"`
	CID2                 string        `json:"cid2"`
	CID2Name             string        `json:"cid2_name"`
	CID3                 string        `json:"cid3"`
	CID3Name             string        `json:"cid3_name"`
	Commission           string        `json:"commission"`
	CommissionRate       string        `json:"commission_rate"`
	PublicCommissionRate string        `json:"public_commission_rate"`
	CouponURL            string        `json:"coupon_url"`
	CouponRemain         string        `json:"conpon_remain"`
	CouponTotal          string        `json:"coupon_total"`
	CouponPrice          string        `json:"coupon_price"`
	CouponStartTime      string        `json:"coupon_start_time"`
	CouponEndTime        string        `json:"coupon_end_time"`
	Discount             string        `json:"discount"`
	DescPct              string        `json:"desc_pct"`
	EvalCount            string        `json:"eval_count"`
	StartTime            string        `json:"start_time"`
	EndTime              string        `json:"end_time"`
	ImageList            []string      `json:"img_list"`
	DetailImgList        []string      `json:"detail_img_list"`
	InOrderCount         string        `json:"inOrderCount"`
	IsFreeFreightRisk    string        `json:"isFreeFreightRisk"`
	IsSelfSale           string        `json:"isSelfSale"`
	LowerPrice           string        `json:"lower_price"`
	LowerPriceType       string        `json:"lower_price_type"`
	LowestCouponPrice    string        `json:"lowestCouponPrice"`
	LgstPct              string        `json:"lgst_pct"`
	MallID               string        `json:"mall_id"`
	MinGroupPrice        string        `json:"min_group_price"`
	MinNormalPrice       string        `json:"min_normal_price"`
	PCGoodsPrice         string        `json:"pc_goods_price"`
	ShopID               string        `json:"shopId"`
	ShopName             string        `json:"shop_name"`
	StoreID              string        `json:"store_id"`
	SourceType           string        `json:"sourceType"`
	Score                string        `json:"score"`
	ServPct              string        `json:"serv_pct"`
	WlGoodsPrice         string        `json:"wl_goods_price"` //卷后价
	AvgDesc              string        `json:"avg_desc"`
	AvgLgst              string        `json:"avg_lgst"`
	AvgServ              string        `json:"avg_serv"`
	CateName             string        `json:"cate_name"`
	ItemURL              string        `json:"item_url"`
	GoodsSign            string        `json:"goods_sign"`
	ShopLogo             string        `json:"shop_logo"`
	UserType             int           `json:"user_type"`
	Video                []interface{} `json:"video"`
	ShopTotalScore       struct {
		LogisticsScore struct {
			Level string `json:"level"`
			Score string `json:"score"`
			Text  string `json:"text"`
		} `json:"logistics_score"`
		ProductScore struct {
			Level string `json:"level"`
			Score string `json:"score"`
			Text  string `json:"text"`
		} `json:"product_score"`
		ServiceScore struct {
			Level string `json:"level"`
			Score string `json:"score"`
			Text  string `json:"text"`
		} `json:"service_score"`
		ShopScore struct {
			Level string `json:"level"`
			Score string `json:"score"`
			Text  string `json:"text"`
		} `json:"shop_score"`
	} `json:"shop_total_score"`
	NextCommissionList struct {
		SelfCommission  float64 `json:"self_commission"`
		SelfBuy         float64 `json:"self_buy"`
		ShareCommission float64 `json:"share_commission"`
	} `json:"next_commission_list"`
}
type PlatformCss struct {
	Name string `json:"name"`
	Type string `json:"type"`
	Icon string `json:"icon"`
}

// ProductDetailResponse productdetail
type ProductDetailResponse struct {
	ClickUrl              string                   `json:"click_url"`
	IsNull                string                   `json:"is_null"`
	IsCanBuy              string                   `json:"is_can_buy"`          //是否能购买
	IsShowCouponList      string                   `json:"is_show_coupon_list"` //是否展示优惠券弹出
	UserCouponAmount      string                   `json:"user_coupon_amount"`  //优惠券额度
	GoodID                string                   `json:"good_id"`
	Provider              string                   `json:"provider"`
	OldProvider           string                   `json:"old_provider"`
	ProviderName          string                   `json:"provider_name"`
	Commission            string                   `json:"commission"`
	OldCommission         string                   `json:"old_commission"`
	ShareCommission       string                   `json:"share_commission"`
	SelfBuy               string                   `json:"self_buy"`     //自购省
	CouponPrice           string                   `json:"coupon_price"` //优惠卷价
	ShopAvatar            string                   `json:"shop_avatar"`
	NewGoodsContent       string                   `json:"new_goods_content"`  //站内商品的文案
	NewGoodsImgList       string                   `json:"new_goods_img_list"` //站内商品的图片组
	GoodsTitle            string                   `json:"goods_title"`        //商品标题
	CommissionRate        string                   `json:"commission_rate"`
	WlGoodsPrice          string                   `json:"wl_goods_price"` //卷后价
	ModList               []map[string]interface{} `json:"mod_list"`
	ModGoodsDetailBgColor string                   `json:"mod_goods_detail_bg_color"`
	SkuParam              map[string]string        `json:"sku_param"`
	CopyUrlParam          map[string]string        `json:"copy_url_param"`
	BackReq               string                   `json:"back_req"`
	SaveNow               string                   `json:"save_now"`
}

// PddPopCss PddPopCss
type PddPopCss struct {
	IsPop      string `json:"is_pop"`
	H5Url      string `json:"no_open_app_url"`
	MiniAPPID  string `json:"mini_appid"`
	MiniUrl    string `json:"mini_url"`
	OpenAppUrl string `json:"open_app_url"`
	SchemaUrl  string `json:"schema_url"`
	Ico        string `json:"ico"`
	BtnIco     string `json:"btn_ico"`
	Title      string `json:"title"`
	Info       string `json:"info"`
	BtnStr     string `json:"btn_str"`
}

//
type ProductDetailVoucher struct {
	BgColor string `json:"bg_color"`
	CateTag string `json:"cate_tag"`
	Color   string `json:"color"`
	Data    struct {
		BrandID string `json:"brand_id"`
	} `json:"data"`
	FinalPrice         string `json:"final_price"`
	Info               string `json:"info"`
	IsJump             string `json:"is_jump"`
	Name               string `json:"name"`
	OfficialPrice      string `json:"official_price"`
	RequiredLogin      string `json:"required_login"`
	RequiredTaobaoAuth string `json:"required_taobao_auth"`
	SaleStr            string `json:"sale_str"`
	SkipIdentifier     string `json:"skip_identifier"`
	SkipName           string `json:"skip_name"`
	SubBgColor         string `json:"sub_bg_color"`
	Tag                string `json:"tag"`
	Title              string `json:"title"`
}

type GoodsProfit struct {
	Commission float64 `json:"commission"`
	Integral   float64 `json:"integral"`
	BlockIcons float64 `json:"block_icons"`
}
