package wph

type GetOrder struct {
	OrderType                        int    `json:"orderType"`
	OrderSn                          string `json:"orderSn"`
	OpenId                           string `json:"openId"`
	FdsBlackOrder                    int    `json:"fdsBlackOrder"`
	EstimateCommissionAfterDeduction string `json:"estimateCommissionAfterDeduction"`
	Pid                              string `json:"pid"`
	OrderTrackReason                 int    `json:"orderTrackReason"`
	OrderSubStatusName               string `json:"orderSubStatusName"`
	OrderQuality                     string `json:"orderQuality"`
	StatParam                        string `json:"statParam"`
	OrderTime                        int64  `json:"orderTime"`
	NewCustomer                      int    `json:"newCustomer"`
	AdCode                           string `json:"adCode"`
	Commission                       string `json:"commission"`
	AppKey                           string `json:"appKey"`
	IsSplit                          int    `json:"isSplit"`
	OrderSource                      string `json:"orderSource"`
	SignTime                         int64  `json:"signTime"`
	Settled                          int    `json:"settled"`
	CommissionEnterTime              int64  `json:"commissionEnterTime"`
	DeductionCommission              string `json:"DeductionCommission"`
	IsPrepay                         int    `json:"isPrepay"`
	BaseCommissionSettleRate         string `json:"baseCommissionSettleRate"`
	DetailList                       []struct {
		SizeId                           string `json:"sizeId"`
		CommissionRate                   string `json:"commissionRate"`
		GoodsId                          string `json:"goodsId"`
		GoodsFinalPrice                  string `json:"goodsFinalPrice"`
		BrandStoreName                   string `json:"brandStoreName"`
		EstimateCommissionAfterDeduction string `json:"estimateCommissionAfterDeduction"`
		Cat2Code                         string `json:"cat2Code"`
		CommCode                         string `json:"commCode"`
		IsSubsidyTaskOrder               bool   `json:"isSubsidyTaskOrder"`
		Commission                       string `json:"commission"`
		Cat3Code                         string `json:"cat3Code"`
		Cat1Name                         string `json:"cat1Name"`
		GoodsName                        string `json:"goodsName"`
		CommissionTotalCost              string `json:"commissionTotalCost"`
		OrderSource                      string `json:"orderSource"`
		BrandStoreSn                     string `json:"brandStoreSn"`
		DeductionCommission              string `json:"DeductionCommission"`
		Cat2Name                         string `json:"cat2Name"`
		BaseCommissionSettleRate         string `json:"baseCommissionSettleRate"`
		GoodsCount                       int    `json:"goodsCount"`
		GoodsThumb                       string `json:"goodsThumb"`
		CommName                         string `json:"commName"`
		SpuId                            string `json:"spuId"`
		Cat1Code                         string `json:"cat1Code"`
		Cat3Name                         string `json:"cat3Name"`
		Status                           int    `json:"status"`
		AfterSaleInfo                    []struct {
			AfterSaleStatus     int    `json:"afterSaleStatus"`
			AfterSaleSn         string `json:"afterSaleSn"`
			AfterSaleFinishTime int64  `json:"afterSaleFinishTime"`
			AfterSaleType       int    `json:"afterSaleType"`
		} `json:"afterSaleInfo,omitempty"`
	} `json:"detailList"`
	SettledTime    int64  `json:"settledTime"`
	ChannelTag     string `json:"channelTag"`
	SelfBuy        int    `json:"selfBuy"`
	TotalCost      string `json:"totalCost"`
	Status         int    `json:"status"`
	LastUpdateTime int64  `json:"lastUpdateTime"`
}
type GetRefundOrder struct {
	OrderSn         string `json:"orderSn"`
	AfterSaleStatus int    `json:"afterSaleStatus"`
}
