package pdd_union

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/md/cps_pdd"
	"encoding/json"
)

//https://open.pinduoduo.com/application/document/api?id=pdd.ddk.oauth.goods.prom.url.generate
func ExtendUrl(keyArr map[string]string, param map[string]interface{}) map[string]string {
	send, _ := Send(keyArr, "pdd.ddk.oauth.goods.prom.url.generate", param)
	var res cps_pdd.ExtendUrl
	json.Unmarshal([]byte(send), &res)
	tmp := map[string]string{
		"url":             "",
		"open_app_url":    "",
		"no_open_app_url": "",
		"page_path":       "",
		"schema_url":      "",
	}
	if param["open_app"] == "<nil>" || param["open_app"] == nil {
		param["open_app"] = ""
	}
	if param["link_type"] == "<nil>" || param["link_type"] == nil {
		param["link_type"] = ""
	}
	for _, v := range res.GoodsPromotionUrlGenerateResponse.GoodsPromotionUrlList {
		tmp["url"] = v.ShortUrl
		tmp["open_app_url"] = v.MobileUrl
		tmp["no_open_app_url"] = v.ShortUrl
		tmp["page_path"] = v.WeAppInfo.PagePath
		tmp["schema_url"] = v.SchemaUrl
		if param["open_app"] == "" && param["link_type"] != "" {
			tmp["url"] = v.Url
		}
		if param["open_app"] != "" {
			tmp["url"] = v.MobileShortUrl
		}
		if param["open_app"] != "" && param["link_type"] != "" {
			tmp["url"] = v.MobileUrl
		}
	}
	return tmp
}

//https://open.pinduoduo.com/application/document/api?id=pdd.ddk.oauth.resource.url.gen
func MainThemeUrl(keyArr map[string]string, param map[string]interface{}) map[string]string {
	send, _ := Send(keyArr, "pdd.ddk.oauth.resource.url.gen", param)
	var res cps_pdd.MainThemeUrl
	json.Unmarshal([]byte(send), &res)
	tmp := map[string]string{
		"url":             "",
		"open_app_url":    "",
		"no_open_app_url": "",
		"page_path":       "",
		"schema_url":      "",
	}
	tmp["url"] = res.ResourceUrlResponse.SingleUrlList.ShortUrl
	tmp["open_app_url"] = res.ResourceUrlResponse.SingleUrlList.MobileUrl
	tmp["short_open_url"] = res.ResourceUrlResponse.SingleUrlList.MobileShortUrl
	tmp["no_open_app_url"] = res.ResourceUrlResponse.SingleUrlList.ShortUrl
	tmp["page_path"] = res.ResourceUrlResponse.WeAppInfo.PagePath
	tmp["schema_url"] = res.ResourceUrlResponse.SingleUrlList.SchemaUrl
	if param["open_app"] == "<nil>" || param["open_app"] == nil {
		param["open_app"] = ""
	}
	if param["link_type"] == "<nil>" || param["link_type"] == nil {
		param["link_type"] = ""
	}
	if param["open_app"] == "" && param["link_type"] != "" {
		tmp["url"] = res.ResourceUrlResponse.SingleUrlList.Url
	}
	if param["open_app"] != "" {
		tmp["url"] = res.ResourceUrlResponse.SingleUrlList.MobileShortUrl
	}
	if param["open_app"] != "" && param["link_type"] != "" {
		tmp["url"] = res.ResourceUrlResponse.SingleUrlList.MobileUrl
	}
	if res.ResourceUrlResponse.SingleUrlList.WeAppInfo.PagePath == "" {
		tmp["page_path"] = res.ResourceUrlResponse.SingleUrlList.WeAppPagePath
	}
	return tmp
}

//https://open.pinduoduo.com/application/document/api?id=pdd.ddk.oauth.goods.zs.unit.url.gen
func WnMainThemeUrl(keyArr map[string]string, param map[string]interface{}) map[string]string {
	send, _ := Send(keyArr, "pdd.ddk.oauth.goods.zs.unit.url.gen", param)
	var res cps_pdd.WnMainThemeUrl
	json.Unmarshal([]byte(send), &res)
	tmp := map[string]string{
		"url":             "",
		"open_app_url":    "",
		"no_open_app_url": "",
		"page_path":       "",
		"schema_url":      "",
	}
	tmp["url"] = res.GoodsZsUnitGenerateResponse.ShortUrl
	tmp["open_app_url"] = res.GoodsZsUnitGenerateResponse.MobileUrl
	tmp["short_open_url"] = res.GoodsZsUnitGenerateResponse.MobileShortUrl
	tmp["no_open_app_url"] = res.GoodsZsUnitGenerateResponse.ShortUrl
	tmp["page_path"] = res.GoodsZsUnitGenerateResponse.WeAppInfo.PagePath
	tmp["schema_url"] = res.GoodsZsUnitGenerateResponse.SchemaUrl
	if param["open_app"] == "<nil>" || param["open_app"] == nil {
		param["open_app"] = ""
	}
	if param["link_type"] == "<nil>" || param["link_type"] == nil {
		param["link_type"] = ""
	}
	if param["open_app"] == "" && param["link_type"] != "" {
		tmp["url"] = res.GoodsZsUnitGenerateResponse.Url
	}
	if param["open_app"] != "" {
		tmp["url"] = res.GoodsZsUnitGenerateResponse.MobileShortUrl
	}
	if param["open_app"] != "" && param["link_type"] != "" {
		tmp["url"] = res.GoodsZsUnitGenerateResponse.MobileUrl
	}
	if res.GoodsZsUnitGenerateResponse.WeAppInfo.PagePath == "" {
		tmp["page_path"] = res.GoodsZsUnitGenerateResponse.WeAppPagePath
	}
	return tmp
}

//https://open.pinduoduo.com/application/document/api?id=pdd.ddk.oauth.rp.prom.url.generate
func RpUrl(keyArr map[string]string, param map[string]interface{}) map[string]string {
	send, _ := Send(keyArr, "pdd.ddk.oauth.rp.prom.url.generate", param)
	var res cps_pdd.RpUrl
	json.Unmarshal([]byte(send), &res)
	tmp := map[string]string{
		"url":             "",
		"open_app_url":    "",
		"no_open_app_url": "",
		"page_path":       "",
		"schema_url":      "",
		"user_name":       "",
		"app_id":          "",
	}
	if param["open_app"] == "<nil>" || param["open_app"] == nil {
		param["open_app"] = ""
	}
	if param["link_type"] == "<nil>" || param["link_type"] == nil {
		param["link_type"] = ""
	}
	for _, v := range res.RpPromotionUrlGenerateResponse.UrlList {
		tmp["url"] = v.ShortUrl
		tmp["open_app_url"] = v.MobileUrl
		tmp["no_open_app_url"] = v.ShortUrl
		tmp["short_open_url"] = v.MobileShortUrl
		tmp["page_path"] = v.WeAppInfo.PagePath
		tmp["user_name"] = v.WeAppInfo.UserName
		tmp["app_id"] = v.WeAppInfo.AppId
		tmp["schema_url"] = v.SchemaUrl
		if param["open_app"] == "" && param["link_type"] != "" {
			tmp["url"] = v.Url
		}
		if param["open_app"] != "" {
			tmp["url"] = v.MobileShortUrl
		}
		if param["open_app"] != "" && param["link_type"] != "" {
			tmp["url"] = v.MobileUrl
		}
	}
	return tmp
}

//https://open.pinduoduo.com/application/document/api?id=pdd.ddk.oauth.cms.prom.url.generate
func PromUrl(keyArr map[string]string, param map[string]interface{}) map[string]string {
	send, _ := Send(keyArr, "pdd.ddk.oauth.cms.prom.url.generate", param)
	var res cps_pdd.PromUrl
	json.Unmarshal([]byte(send), &res)
	tmp := map[string]string{
		"url":             "",
		"open_app_url":    "",
		"no_open_app_url": "",
		"page_path":       "",
		"schema_url":      "",
		"user_name":       "",
		"app_id":          "",
	}
	for _, v := range res.CmsPromotionUrlGenerateResponse.UrlList {
		tmp["url"] = v.ShortUrl
		tmp["open_app_url"] = v.MobileUrl
		tmp["no_open_app_url"] = v.ShortUrl
		tmp["page_path"] = v.WeAppInfo.PagePath
		tmp["user_name"] = v.WeAppInfo.UserName
		tmp["short_open_url"] = v.MobileShortUrl
		tmp["app_id"] = v.WeAppInfo.AppId
		tmp["schema_url"] = v.SchemaUrl
		if param["open_app"] == "" && param["link_type"] != "" && v.Url != "" {
			tmp["url"] = v.Url
		}
		if param["open_app"] != "" && v.MobileShortUrl != "" {
			tmp["url"] = v.MobileShortUrl
		}
		if param["open_app"] != "" && param["link_type"] != "" && v.MobileUrl != "" {
			tmp["url"] = v.MobileUrl
		}
	}
	return tmp
}
