package pdd_union

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/md/cps_pdd"
	zhios_third_party_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/utils"
	"encoding/json"
	"strings"
)

func GetOrder(keyArr map[string]string, param map[string]interface{}) ([]map[string]string, int) {
	send, _ := Send(keyArr, "pdd.ddk.order.list.increment.get", param)
	var res cps_pdd.CpsPddOrder
	json.Unmarshal([]byte(send), &res)
	var data = make([]map[string]string, 0)
	for _, v := range res.OrderListGetResponse.OrderList {
		if v.OrderStatus == -1 {
			continue
		}
		tmp := map[string]string{}
		tmp["check_success_time"] = zhios_third_party_utils.IntToStr(v.OrderVerifyTime)
		tmp["oid"] = v.OrderSn
		tmp["gid"] = v.GoodsSign
		tmp["goods_title"] = v.GoodsName
		tmp["commission"] = zhios_third_party_utils.Float64ToStr(float64(v.PromotionAmount)/100 + float64(v.SubsidyAmount)/100)
		tmp["commission_rate"] = zhios_third_party_utils.Float64ToStr(float64(v.PromotionRate) / 10)
		tmp["goods_price"] = zhios_third_party_utils.Float64ToStr(float64(v.GoodsPrice) / 100)
		tmp["payment"] = zhios_third_party_utils.Float64ToStr(float64(v.OrderAmount) / 100)
		tmp["goods_img"] = v.GoodsThumbnailUrl
		tmp["goods_num"] = zhios_third_party_utils.IntToStr(v.GoodsQuantity)
		tmp["create_time"] = zhios_third_party_utils.IntToStr(v.OrderCreateTime)
		tmp["payment_time"] = zhios_third_party_utils.IntToStr(v.OrderPayTime)
		tmp["update_time"] = zhios_third_party_utils.IntToStr(v.OrderModifyAt)
		tmp["settle_time"] = zhios_third_party_utils.IntToStr(v.OrderSettleTime)
		tmp["order_receive_time"] = zhios_third_party_utils.IntToStr(v.OrderReceiveTime)
		tmp["status_str"] = v.OrderStatusDesc
		tmp["pdd_pid"] = v.PId
		tmp["fail_status"] = v.FailReason
		tmp["custom_parameters"] = v.CustomParameters
		tmp["status_str"] = v.OrderStatusDesc
		tmp["ord_type"] = "0"
		if strings.Contains(v.FailReason, "比价") || v.PriceCompareStatus == 1 {
			tmp["ord_type"] = "1"
		}
		data = append(data, tmp)
	}
	return data, res.OrderListGetResponse.TotalCount
}
