package taobao

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/db"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/db/model"
	zhios_third_party_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/utils"
	"encoding/json"
	"time"
	"xorm.io/xorm"
)

func TaobaoRelationPid(eg *xorm.Engine, args map[string]string) (bool, string, string) {
	mid := args["mid"]
	uid := zhios_third_party_utils.StrToInt(args["uid"])
	//查询方案 有多少个推广位
	taobaoCfg, err := db.SysUnionByTaobaoByUseByAuth(eg, mid)
	if err != nil || taobaoCfg == nil {
		return false, "", ""
	}
	if taobaoCfg.AppletPid == "" {
		return false, "", ""
	}
	relationList := db.IsExistRelationPid(eg, uid, taobaoCfg.Id)
	if relationList != nil {
		return true, relationList.RelationId, relationList.Pid
	}
	var r = make([]string, 0)
	err = json.Unmarshal([]byte(taobaoCfg.AppletPid), &r)
	if err != nil {
		return false, "", ""
	}
	//查下还有没有渠道id绑定
	relationId, lid := db.GetRelation(eg, taobaoCfg.Id, len(r))
	if relationId == "" {
		return false, "", ""
	}
	//查下哪个推广位没绑定的
	pidList := db.GetRelationPid(eg, taobaoCfg.Id, r, relationId)
	var pidMap = make([]string, 0)
	for _, v := range *pidList {
		pidMap = append(pidMap, v.Pid)
	}
	pid := ""
	for _, v := range r {
		if zhios_third_party_utils.InArr(v, pidMap) == false && pid == "" {
			pid = v
		}
	}
	if pid == "" {
		return false, "", ""
	}
	var tmp = &model.TaobaoRelationPid{RelationId: relationId, Uid: uid, UnionId: taobaoCfg.Id, Pid: pid, ShortPid: AdZoneId(pid), Time: time.Now()}
	_, err = eg.Insert(tmp)
	if err != nil {
		return false, "", ""
	}
	sql := `UPDATE taobao_relation set count=count+1 where id=? `
	db.QueryNativeString(eg, sql, lid)
	return true, relationId, pid
}
