package tik_tok

import (
	zhios_third_party_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/utils"
	"github.com/tidwall/gjson"
	"time"
)

//第一次授权
func FirstAuth(args map[string]string) map[string]string {
	params := map[string]interface{}{"code": args["code"], "grant_type": args["grantType"]}
	send, err := Send(args["appkey"], args["appSecret"], "token.create", params, args["acctoken"])
	var data = map[string]string{}
	if err != nil {
		return data
	}
	endTime := time.Now().Unix() + gjson.Get(send, "data.expires_in").Int() - 10
	data = map[string]string{
		"tik_tok_acc_token":         gjson.Get(send, "data.access_token").String(),
		"tik_tok_acc_token_time":    zhios_third_party_utils.Int64ToStr(endTime),
		"tik_tok_acc_refresh_token": gjson.Get(send, "data.refresh_token").String(),
	}
	return data
}
func RefreshAuth(args map[string]string) map[string]string {
	params := map[string]interface{}{"refresh_token": args["refresh_token"], "grant_type": "refresh_token"}
	send, err := Send(args["appkey"], args["appSecret"], "token.refresh", params, args["acctoken"])
	var data = map[string]string{}
	if err != nil {
		return data
	}
	endTime := time.Now().Unix() + gjson.Get(send, "data.expires_in").Int() - 10
	data = map[string]string{
		"tik_tok_acc_token":         gjson.Get(send, "data.access_token").String(),
		"tik_tok_acc_token_time":    zhios_third_party_utils.Int64ToStr(endTime),
		"tik_tok_acc_refresh_token": gjson.Get(send, "data.refresh_token").String(),
	}
	return data
}
