package tik_tok

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/md"
	zhios_third_party_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/utils"
	"errors"
	"fmt"
	"github.com/syyongx/php2go"
	"github.com/tidwall/gjson"
)

//创建推广位
func GoodsCreatePid(args map[string]string) map[string]string {

	params := map[string]interface{}{"media_type": "4", "media_name": args["media_name"], "site_name": args["site_name"]}
	send, err := Send(args["appkey"], args["appSecret"], "buyin.kolPidCreate", params, args["acctoken"])
	fmt.Println(send)
	var data = map[string]string{}
	if err != nil {
		return data
	}
	data["pid"] = gjson.Get(send, "data.pid").String()
	return data
}
func GoodsConvertUrl(args map[string]string) (map[string]string, string) {

	params := map[string]interface{}{"pid": args["pid"], "external_info": args["external_info"], "product_url": args["product_url"], "need_share_link": true}
	if args["need_qr_code"] == "1" {
		params["need_qr_code"] = "true"
	}
	send, err := Send(args["appkey"], args["appSecret"], "buyin.kolProductShare", params, args["acctoken"])
	var data = map[string]string{}
	if err != nil {
		fmt.Println("抖音信息=====", send)
		return data, err.Error()
	}
	if gjson.Get(send, "code").Int() != 10000 {
		fmt.Println("抖音信息=====", send)

		return data, gjson.Get(send, "sub_msg").String()
	}
	data["deeplink"] = gjson.Get(send, "data.dy_deeplink").String()
	data["share_link"] = gjson.Get(send, "data.share_link").String()
	data["content"] = php2go.Base64Encode(gjson.Get(send, "data.dy_password").String())
	data["qr_code"] = gjson.Get(send, "data.qr_code.url").String()

	return data, ""
}
func ActConvertUrl(args map[string]string) (map[string]string, string) {
	need_qr_code := "false"
	if args["need_qr_code"] == "1" {
		need_qr_code = "true"
	}
	params := map[string]interface{}{"pid": args["pid"], "external_info": args["external_info"], "activity_id": args["activity_id"], "mix_activity_id": args["mix_activity_id"], "need_qr_code": need_qr_code}
	send, err := Send(args["appkey"], args["appSecret"], "buyin.activityShareConvert", params, args["acctoken"])
	var data = map[string]string{}
	if err != nil {
		fmt.Println("抖音信息=====", send)

		return data, err.Error()
	}
	if gjson.Get(send, "code").Int() != 10000 {
		fmt.Println("抖音信息=====", send)

		return data, gjson.Get(send, "sub_msg").String()
	}
	data["deeplink"] = gjson.Get(send, "data.deep_link").String()
	data["content"] = php2go.Base64Encode(gjson.Get(send, "data.share_command").String())
	data["qr_code"] = gjson.Get(send, "data.qrcode.url").String()

	return data, ""
}
func DkActConvertUrl(args map[string]string) (map[string]string, string) {
	need_qr_code := "false"
	if args["need_qr_code"] == "1" {
		need_qr_code = "true"
	}
	params := map[string]interface{}{"pid": args["pid"], "external_info": args["external_info"], "material_id": zhios_third_party_utils.AnyToInt64(args["material_id"]), "need_qr_code": need_qr_code}
	send, err := Send(args["appkey"], args["appSecret"], "buyin.doukeActivityShare", params, args["acctoken"])
	var data = map[string]string{}
	if err != nil {
		fmt.Println("抖音信息=====", send)

		return data, err.Error()
	}
	if gjson.Get(send, "code").Int() != 10000 {
		fmt.Println("抖音信息=====", send)

		return data, gjson.Get(send, "sub_msg").String()
	}
	data["deeplink"] = gjson.Get(send, "data.deep_link").String()
	data["content"] = php2go.Base64Encode(gjson.Get(send, "data.share_command").String())
	data["qr_code"] = gjson.Get(send, "data.qrcode.url").String()

	return data, ""
}
func LiveCreatePid(args map[string]string) map[string]string {

	params := map[string]interface{}{"media_type": "4", "media_name": args["media_name"], "site_name": args["site_name"]}
	send, err := Send(args["appkey"], args["appSecret"], "buyin.institutePidCreate", params, args["acctoken"])
	fmt.Println(send)
	var data = map[string]string{}
	if err != nil {
		return data
	}
	data["pid"] = gjson.Get(send, "data.pid").String()
	return data
}
func LiveConvertUrl(args map[string]string) (map[string]string, string) {

	params := map[string]interface{}{"pid_info": map[string]interface{}{"pid": args["pid"], "external_info": args["external_info"]}, "buyin_id": args["open_id"]}
	if args["need_qr_code"] == "1" {
		params["need_qr_code"] = "true"
	}
	if args["dy_code"] != "" {
		params["dy_code"] = args["dy_code"]
	}
	if args["product_id"] != "" {
		params["product_id"] = args["product_id"]
	}
	send, err := Send(args["appkey"], args["appSecret"], "buyin.instituteLiveShare", params, args["acctoken"])
	var data = map[string]string{}
	if err != nil {
		fmt.Println("抖音信息=====", send)
		return data, err.Error()
	}
	if gjson.Get(send, "code").Int() != 10000 {
		fmt.Println("抖音信息=====", send)
		return data, gjson.Get(send, "sub_msg").String()
	}
	data["deeplink"] = gjson.Get(send, "data.dy_deeplink").String()
	data["content"] = php2go.Base64Encode(gjson.Get(send, "data.dy_password").String())
	data["qr_code"] = gjson.Get(send, "data.qr_code.url").String()

	return data, ""
}

func RegimentalConvertUrl(args map[string]string) (map[string]string, string) {

	params := map[string]interface{}{"pid_info": map[string]interface{}{"pid": args["pid"], "external_info": args["external_info"]}, "open_id": args["open_id"]}
	send, err := Send(args["appkey"], args["appSecret"], "buyin.instituteLiveShare", params, args["acctoken"])
	fmt.Println(send)
	var data = map[string]string{}
	if err != nil {
		return data, err.Error()
	}
	if gjson.Get(send, "code").Int() != 10000 {
		return data, gjson.Get(send, "sub_msg").String()
	}
	data["deeplink"] = gjson.Get(send, "data.dy_deeplink").String()
	data["content"] = php2go.Base64Encode(gjson.Get(send, "data.dy_password").String())
	data["qr_code"] = gjson.Get(send, "data.qr_code.url").String()

	return data, ""
}
func OwnTikTokUrl(tikTokBase *md.TikTokBase, tikTokArgs map[string]interface{}) (*md.ConvertedUrls, error) {
	args := map[string]string{
		"appkey":        tikTokBase.ApiGoodsAppKey,
		"appSecret":     tikTokBase.ApiGoodsAppSecret,
		"product_url":   zhios_third_party_utils.AnyToString(tikTokArgs["product_url"]),
		"external_info": zhios_third_party_utils.AnyToString(tikTokArgs["external_info"]),
		"need_qr_code":  zhios_third_party_utils.AnyToString(tikTokArgs["need_qr_code"]),
		"pid":           tikTokBase.GoodsPid,
		"acctoken":      tikTokBase.GoodsAccessToken,
	}
	fmt.Println("抖音", args)
	url, err := GoodsConvertUrl(args)
	if err != "" {
		return nil, errors.New(err)
	}
	content, _ := php2go.Base64Decode(url["content"])
	return &md.ConvertedUrls{
		URL:          url["deeplink"],
		ShortenURL:   url["deeplink"],
		NoOpenAppURL: url["deeplink"],
		AppURL:       url["deeplink"],
		ClickUrl:     url["deeplink"],
		QrcodeUrl:    url["qr_code"],
		Content:      content,
		H5Url:        url["share_link"],
	}, nil
}
func OwnTikTokActUrl(tikTokBase *md.TikTokBase, tikTokArgs map[string]interface{}) (*md.ConvertedUrls, error) {
	args := map[string]string{
		"appkey":          tikTokBase.ApiGoodsAppKey,
		"appSecret":       tikTokBase.ApiGoodsAppSecret,
		"activity_id":     zhios_third_party_utils.AnyToString(tikTokArgs["activity_id"]),
		"mix_activity_id": zhios_third_party_utils.AnyToString(tikTokArgs["mix_activity_id"]),
		"need_qr_code":    zhios_third_party_utils.AnyToString(tikTokArgs["need_qr_code"]),
		"external_info":   zhios_third_party_utils.AnyToString(tikTokArgs["external_info"]),
		"pid":             tikTokBase.GoodsPid,
		"acctoken":        tikTokBase.GoodsAccessToken,
	}
	fmt.Println("抖音", args)
	var url map[string]string
	var err string
	if tikTokBase.AuthSubjectType == "DouKe" {
		args["material_id"] = zhios_third_party_utils.AnyToString(tikTokArgs["material_id"])
		url, err = DkActConvertUrl(args)
	} else {
		url, err = ActConvertUrl(args)
	}
	//url, err = tik_tok.ActConvertUrl(args)

	if err != "" {
		return nil, errors.New(err)
	}
	content, _ := php2go.Base64Decode(url["content"])
	return &md.ConvertedUrls{
		URL:          url["deeplink"],
		ShortenURL:   url["deeplink"],
		NoOpenAppURL: url["deeplink"],
		AppURL:       url["deeplink"],
		ClickUrl:     url["deeplink"],
		QrcodeUrl:    url["qr_code"],
		Content:      content,
	}, nil
}
