package tik_tok

import (
	zhios_third_party_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/utils"
	"encoding/json"
	"github.com/tidwall/gjson"
)

func LiveList(args map[string]string) []TikTokLive {
	params := map[string]interface{}{"page": args["page"], "page_size": args["page_size"]}
	if args["author_type"] != "" {
		params["author_type"] = args["author_type"]
	}
	if args["author_levels"] != "" {
		params["author_levels"] = []string{args["author_levels"]}
	}
	if args["first_cids"] != "" {
		params["first_cids"] = []string{args["first_cids"]}
	}
	if args["keyword"] != "" {
		params["keyword"] = args["keyword"]
	}
	if args["sell_num_max"] != "" {
		params["sell_num_max"] = args["sell_num_max"]
	}
	if args["sort_type"] != "" {
		params["sort_type"] = args["sort_type"]
	}
	if args["sort_by"] != "" {
		params["sort_by"] = args["sort_by"]
	}
	send, err := Send(args["appkey"], args["appSecret"], "buyin.liveShareMaterial", params, args["acctoken"])
	var goodsList = make([]TikTokLive, 0)
	product := gjson.Get(send, "data.data").String()
	if err != nil || product == "" {
		return goodsList
	}
	var tmpList = make([]interface{}, 0)
	err = json.Unmarshal([]byte(product), &tmpList)
	if err != nil {
		return goodsList
	}
	for _, v := range tmpList {
		goods := v.(map[string]interface{})
		if zhios_third_party_utils.AnyToBool(goods["is_live"]) == false {
			continue
		}
		tmp := TikTokLive{
			LiveId:  zhios_third_party_utils.AnyToString(goods["author_openid"]),
			Name:    zhios_third_party_utils.AnyToString(goods["author_name"]),
			HeadImg: zhios_third_party_utils.AnyToString(goods["author_pic"]),
			FansNum: zhios_third_party_utils.AnyToString(goods["fans_num"]),
			Pvd:     "tikTok",
		}
		goodsList = append(goodsList, tmp)
	}
	return goodsList
}
