package tik_tok

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/md"
	zhios_third_party_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/utils"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/zhimeng"
	"fmt"
	"github.com/jinzhu/copier"
)

func OwnTeamGoods(tikTokBase *md.TikTokBase, tikTokArgs map[string]interface{}) (*[]zhimeng.TikTokData, error) {
	var data = make([]zhimeng.TikTokData, 0)
	var list = make([]TikTokGoods, 0)
	args := map[string]string{
		"appkey":      tikTokBase.ApiTeamAppKey,
		"appSecret":   tikTokBase.ApiTeamAppSecret,
		"acctoken":    zhios_third_party_utils.AnyToString(tikTokArgs["token"]),
		"activity_id": zhios_third_party_utils.AnyToString(tikTokArgs["category_id"]),
		"search_type": "0",
		"sort_type":   "1",
		"status":      "1",
		"page":        zhios_third_party_utils.AnyToString(tikTokArgs["p"]),
		"count":       zhios_third_party_utils.AnyToString(tikTokArgs["size"]),
	}
	if tikTokArgs["gid"] != "" {
		args["product_info"] = zhios_third_party_utils.AnyToString(tikTokArgs["gid"])
	}
	for k, v := range args {
		if v == "<nil>" {
			args[k] = ""
		}
	}
	list, _, _ = ActivityProduct(args)
	if list == nil {
		return &data, nil
	}
	err := copier.Copy(&data, list)
	if err != nil {
		return &data, nil
	}
	return &data, nil
}

func OwnTeamUrl(tikTokBase *md.TikTokBase, tikTokArgs map[string]interface{}) (map[string]string, error) {
	args := map[string]string{
		"appkey":      tikTokBase.ApiTeamAppKey,
		"appSecret":   tikTokBase.ApiTeamAppSecret,
		"acctoken":    tikTokBase.TeamAccessToken,
		"product_url": zhios_third_party_utils.AnyToString(tikTokArgs["product_url"]),
		"pick_extra":  zhios_third_party_utils.AnyToString(tikTokArgs["pick_extra"]),
	}
	if tikTokArgs["newTeamToken"] != "" && tikTokArgs["newTeamToken"] != nil {
		args["acctoken"] = zhios_third_party_utils.AnyToString(tikTokArgs["newTeamToken"])
	}
	for k, v := range args {
		if v == "<nil>" {
			args[k] = ""
		}
	}
	fmt.Println("抖音", args)
	var data = make(map[string]string, 0)
	list := ProductUrl(args)
	if list == nil {
		return data, nil
	}
	return list, nil
}
