package tik_tok

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/md"
	zhios_third_party_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/utils"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/zhimeng"
	"fmt"
	"github.com/jinzhu/copier"
	"xorm.io/xorm"
)

func TikTokSearchGoods(eg *xorm.Engine, dbName string, params map[string]interface{}) []map[string]string {
	var goods = make([]map[string]string, 0)
	tikTokBase, _ := Base(eg, dbName, "")
	var list *[]zhimeng.TikTokData
	var err error
	if zhios_third_party_utils.InArr(tikTokBase.AuthType, []string{"2", "3"}) {
		list, err = OwnTikTokGoods(tikTokBase, params)
	} else {
		list, err = zhimeng.TikTokGoods(params)
	}
	fmt.Println(err)
	if list != nil {
		for _, v := range *list {
			var tmp = map[string]string{
				"img_list":        zhios_third_party_utils.SerializeStr(v.Imgs),
				"gid":             v.GoodsID,
				"title":           v.GoodsTitle,
				"img":             v.GoodsImg,
				"sales":           v.GoodsSales,
				"price":           v.Price,
				"cost_price":      v.CostPrice,
				"coupon":          v.YhqPrice,
				"commission_rate": zhios_third_party_utils.AnyToString(v.Commission),
				"commission":      zhios_third_party_utils.Float64ToStr(zhios_third_party_utils.StrToFloat64(v.Price) * (zhios_third_party_utils.AnyToFloat64(v.Commission) / 100)),
				"pvd":             md.PVD_TIKTOK,
				"share_content":   "",
			}
			goods = append(goods, tmp)
		}
	}
	return goods
}
func OwnTikTokGoods(tikTokBase *md.TikTokBase, tikTokArgs map[string]interface{}) (*[]zhimeng.TikTokData, error) {
	args := map[string]string{
		"appkey":        tikTokBase.ApiGoodsAppKey,
		"appSecret":     tikTokBase.ApiGoodsAppSecret,
		"title":         zhios_third_party_utils.AnyToString(tikTokArgs["keyword"]),
		"first_cids":    zhios_third_party_utils.AnyToString(tikTokArgs["category_id"]),
		"price_min":     zhios_third_party_utils.AnyToString(tikTokArgs["start_price"]),
		"price_max":     zhios_third_party_utils.AnyToString(tikTokArgs["end_price"]),
		"sell_num_min":  zhios_third_party_utils.AnyToString(tikTokArgs["start_sales"]),
		"sell_num_max":  zhios_third_party_utils.AnyToString(tikTokArgs["end_sales"]),
		"sort":          zhios_third_party_utils.AnyToString(tikTokArgs["sort"]),
		"cos_ratio_min": zhios_third_party_utils.AnyToString(tikTokArgs["start_commission"]),
		"cos_ratio_max": zhios_third_party_utils.AnyToString(tikTokArgs["end_commission"]),
		"page":          zhios_third_party_utils.AnyToString(tikTokArgs["p"]),
		"page_size":     zhios_third_party_utils.AnyToString(tikTokArgs["size"]),
		"acctoken":      tikTokBase.SysGoodsAccessToken,
	}
	for k, v := range args {
		if v == "<nil>" {
			args[k] = ""
		}
	}
	if args["sort"] == "" {
		args["sort"] = "default"
	}
	if zhios_third_party_utils.StrToInt(args["first_cids"]) == 0 {
		args["first_cids"] = ""
	}
	var data = make([]zhimeng.TikTokData, 0)
	list := GoodsList(args)
	if list == nil {
		return &data, nil
	}
	err := copier.Copy(&data, list)
	if err != nil {
		return &data, nil
	}
	return &data, nil
}
