package zhimeng

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/md"
	"encoding/json"
	"github.com/syyongx/php2go"
)

func KuaiShouUrl(tikTokArgs map[string]interface{}) (*md.ConvertedUrls, error) {
	args := map[string]interface{}{
		"appkey":        tikTokArgs["appkey"],
		"secret_key":    tikTokArgs["secret_key"],
		"linkCarrierId": tikTokArgs["gid"],
		"comments":      tikTokArgs["external_info"],
		"linkType":      tikTokArgs["linkType"],
		"genPoster":     tikTokArgs["genPoster"],
	}
	resp, err := Send("kuaishou", "getUrls", args)
	if err != nil {
		return nil, err
	}
	var tmp struct {
		Data TikTokUrlData `json:"data"`
	}
	if err = json.Unmarshal(resp, &tmp); err != nil {
		return nil, err
	}
	content, _ := php2go.Base64Decode(tmp.Data.Content)
	return &md.ConvertedUrls{
		URL:             tmp.Data.Deeplink,
		ShortenURL:      tmp.Data.Deeplink,
		NoOpenAppURL:    tmp.Data.Link,
		AppURL:          tmp.Data.Deeplink,
		ClickUrl:        tmp.Data.Deeplink,
		QrcodeUrl:       tmp.Data.QrCode,
		Content:         content,
		WeChatMiniURL:   tmp.Data.PageUrl,
		WeChatMiniAPPID: tmp.Data.AppId,
	}, nil
}
