package zhimeng

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/db/model"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/md"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/pdd_union"
	zhios_third_party_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/utils"
	"errors"
	"github.com/tidwall/gjson"
)

func pddcomm() map[string]string {
	keyArr := map[string]string{
		"app_key":    "43eed45f20d94fbf828744a77a45e3e2",
		"app_secret": "4ee672167e1ee51aa3a9ea864d33629a230a114c",
	}
	return keyArr
}
func OwnAuthUrl(auth *model.SysUnionSet, pid string) string {
	keyArr := pddcomm()
	param := map[string]interface{}{
		"access_token":      gjson.Get(auth.KeyData, "accessToken").String(),
		"pid":               gjson.Get(auth.KeyData, "pid").String(),
		"custom_parameters": "{\"uid\":\"" + pid + "\"}",
	}

	return pdd_union.CheckAuthUrl(keyArr, param)
}
func OwnPDDConvertUrl(auth *model.SysUnionSet, itemId, pid, couponPrice, isWxMini, isBindUrl, isShare string) (*md.ConvertedUrls, error) {
	keyArr := pddcomm()
	buyType := "self"
	if isShare == "1" {
		buyType = "share"
	}
	if isShare == "2" {
		buyType = "cloud"
	}
	if isShare == "3" {
		buyType = "free"
	}
	param := map[string]interface{}{
		"access_token":        gjson.Get(auth.KeyData, "accessToken").String(),
		"p_id":                gjson.Get(auth.KeyData, "pid").String(),
		"goods_sign_list":     zhios_third_party_utils.SerializeStr([]string{itemId}),
		"generate_short_url":  "true",
		"generate_schema_url": "true",
		"multi_group":         "true",
		"custom_parameters":   "{\"uid\":\"" + pid + "\",\"buy_type\":\"" + buyType + "\"}",
	}
	if isWxMini == "1" {
		param["generate_we_app"] = "true"
	}
	if isBindUrl == "1" {
		param["generate_authority_url"] = "true"
	}
	url := pdd_union.ExtendUrl(keyArr, param)
	if url["url"] == "" {
		return nil, errors.New("转链失败")
	}
	return &md.ConvertedUrls{
		ItemId:         itemId,
		URL:            url["url"],
		ShortenURL:     url["no_open_app_url"],
		NoOpenAppURL:   url["open_app_url"],
		AppURL:         url["schema_url"],
		HasCoupon:      false,
		CommissionRate: couponPrice,
		WeChatMiniURL:  url["page_path"],
	}, nil
}

// 生成多多进宝频道推广
func OwnPDDActivityConvertUrl(auth *model.SysUnionSet, resourceType, pid, urls string, isShare int) (*md.ConvertedUrls, error) {
	keyArr := pddcomm()
	buyType := "self"
	if isShare == 1 {
		buyType = "share"
	}
	param := map[string]interface{}{
		"access_token":        gjson.Get(auth.KeyData, "accessToken").String(),
		"pid":                 gjson.Get(auth.KeyData, "pid").String(),
		"resource_type":       resourceType,
		"url":                 urls,
		"generate_short_url":  "true",
		"generate_schema_url": "true",
		"generate_mobile":     "true",
		"custom_parameters":   "{\"uid\":\"" + pid + "\",\"buy_type\":\"" + buyType + "\"}",
	}
	url := pdd_union.MainThemeUrl(keyArr, param)
	if url["url"] == "" {
		return nil, errors.New("转链失败")
	}
	return &md.ConvertedUrls{
		URL:           url["url"],
		ShortenURL:    url["no_open_app_url"],
		NoOpenAppURL:  url["open_app_url"],
		AppURL:        url["schema_url"],
		WeChatMiniURL: url["page_path"],
	}, nil

}
func OwnPDDWnConvertUrl(auth *model.SysUnionSet, pid, urls string, isShare int) (*md.ConvertedUrls, error) {
	keyArr := pddcomm()
	buyType := "self"
	if isShare == 1 {
		buyType = "share"
	}
	param := map[string]interface{}{
		"access_token":        gjson.Get(auth.KeyData, "accessToken").String(),
		"pid":                 gjson.Get(auth.KeyData, "pid").String(),
		"source_url":          urls,
		"generate_short_url":  "true",
		"generate_schema_url": "true",
		"generate_mobile":     "true",
		"custom_parameters":   "{\"uid\":\"" + pid + "\",\"buy_type\":\"" + buyType + "\"}",
	}
	url := pdd_union.WnMainThemeUrl(keyArr, param)
	if url["url"] == "" {
		return nil, errors.New("转链失败")
	}
	return &md.ConvertedUrls{
		URL:           url["url"],
		ShortenURL:    url["no_open_app_url"],
		NoOpenAppURL:  url["open_app_url"],
		AppURL:        url["schema_url"],
		WeChatMiniURL: url["page_path"],
	}, nil
}

// 生成商城-频道推广链接
func OwnPDDActivityStoreConvertUrl(auth *model.SysUnionSet, resourceType, pid, urls string, isShare int) (*md.ConvertedUrls, error) {
	keyArr := pddcomm()
	buyType := "self"
	if isShare == 1 {
		buyType = "share"
	}
	param := map[string]interface{}{
		"access_token":           gjson.Get(auth.KeyData, "accessToken").String(),
		"p_id_list":              zhios_third_party_utils.SerializeStr([]string{gjson.Get(auth.KeyData, "pid").String()}),
		"channel_type":           resourceType,
		"generate_short_url":     "true",
		"generate_schema_url":    "true",
		"generate_weapp_webview": "false",
		"generate_we_app":        "true",
		"custom_parameters":      "{\"uid\":\"" + pid + "\",\"buy_type\":\"" + buyType + "\"}",
	}
	url := pdd_union.PromUrl(keyArr, param)
	if url["url"] == "" {
		return nil, errors.New("转链失败")
	}
	return &md.ConvertedUrls{
		URL:           url["url"],
		ShortenURL:    url["no_open_app_url"],
		NoOpenAppURL:  url["open_app_url"],
		AppURL:        url["schema_url"],
		WeChatMiniURL: url["page_path"],
	}, nil
}

// 生成营销工具推广链接
func OwnPDDActivitySaleConvertUrl(auth *model.SysUnionSet, resourceType, pid string, isShare int) (*md.ConvertedUrls, error) {

	keyArr := pddcomm()
	buyType := "self"
	if isShare == 1 {
		buyType = "share"
	}
	param := map[string]interface{}{
		"access_token":           gjson.Get(auth.KeyData, "accessToken").String(),
		"p_id_list":              zhios_third_party_utils.SerializeStr([]string{gjson.Get(auth.KeyData, "pid").String()}),
		"channel_type":           resourceType,
		"generate_short_url":     "true",
		"generate_schema_url":    "true",
		"generate_weapp_webview": "false",
		"generate_we_app":        "true",
		"custom_parameters":      "{\"uid\":\"" + pid + "\",\"buy_type\":\"" + buyType + "\"}",
	}
	url := pdd_union.RpUrl(keyArr, param)
	if url["url"] == "" {
		return nil, errors.New("转链失败")
	}
	return &md.ConvertedUrls{
		URL:           url["url"],
		ShortenURL:    url["no_open_app_url"],
		NoOpenAppURL:  url["open_app_url"],
		AppURL:        url["schema_url"],
		WeChatMiniURL: url["page_path"],
	}, nil
}
