package zhimeng

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/db/model"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/md"
	zhios_third_party_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/utils"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/wph"
	"encoding/json"
	"github.com/syyongx/php2go"
	"github.com/tidwall/gjson"
	"time"
)

func GetWphPid(uid int, shareType, dbName string) string {
	newpid := "own_" + shareType + "_" + dbName + "_0"
	if uid > 0 {
		newpid = "own_" + shareType + "_" + dbName + "_" + zhios_third_party_utils.IntToStr(uid)
	}
	return newpid

}
func OwnWphToStruct(data string, r *md.MoreDetailResponse) error {

	if err := json.Unmarshal([]byte(data), r); err != nil {
		return err
	}
	return nil
}
func OwnWphDetail(auth *model.SysUnionSet, postData map[string]interface{}) string {
	serviceParam := CommWph(auth)
	realCall := "false"
	if postData["realCall"] == "1" {
		realCall = "true"
	}
	serviceParam["token"] = gjson.Get(auth.KeyData, "accessToken").String()
	paramData := map[string]interface{}{
		"goodsIdList": []string{zhios_third_party_utils.AnyToString(postData["gid"])},
		"requestId":   serviceParam["uuid"] + zhios_third_party_utils.Int64ToStr(time.Now().Unix()) + zhios_third_party_utils.IntToStr(php2go.Rand(1000, 9999)),
		"request": map[string]string{
			"realCall": realCall,
			"openId":   zhios_third_party_utils.AnyToString(postData["openId"]),
		},
		"chanTag": zhios_third_party_utils.AnyToString(postData["pid"]),
	}
	param := zhios_third_party_utils.SerializeStr(paramData)
	res1 := wph.GetByGoodsIdsWithOauth(serviceParam, param)
	if len(res1) > 0 {
		return zhios_third_party_utils.SerializeStr(res1[0])

	}
	return ""

}

func OwnWphParseUrl(auth *model.SysUnionSet, content string) string {
	serviceParam := CommWph(auth)
	serviceParam["token"] = gjson.Get(auth.KeyData, "accessToken").String()
	paramData := map[string]interface{}{
		"vipLinkCheckReq": map[string]string{
			"source":  "唯品会",
			"content": content,
		},
	}
	param := zhios_third_party_utils.SerializeStr(paramData)
	res1 := wph.GetParseUrl(serviceParam, param)
	return zhios_third_party_utils.AnyToString(res1["goodsId"])

}
