package zhimeng

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/md"
	"encoding/json"
	"fmt"
	"github.com/syyongx/php2go"
)

// 转链后, 可以通过链接拼装&relationId(int)或者&externalId(string)(二选一)进行订单获取
func TaobaoConvertUrl(appkey, appsecret, itemId, tbPid, tbSid string, tbExternalId, tbAppKey string) (*md.ConvertedUrls, error) {
	args := map[string]interface{}{
		"appkey":          appkey,
		"secret_key":      appsecret,
		"gid":             itemId,
		"new_external_id": tbExternalId, //自定义参数 只有要生成备案链接用
		"pid":             tbPid,
		"tb_app_key":      tbAppKey,
		"session":         tbSid, //tbSid
	}
	fmt.Println(args)
	if php2go.IsNumeric(itemId) {
		args["biz_scene_id"] = "2"
	}
	resp, err := Send("agent_tb", "url", args)
	if err != nil {
		return nil, err
	}
	var tmp struct {
		Success int `json:"success"`
		Data    struct {
			HaveCoupon        string `json:"have_coupon"`
			URL               string `json:"url"`
			MaxCommissionRate string `json:"max_commission_rate"`
		} `json:"data"`
	}
	if err = json.Unmarshal(resp, &tmp); err != nil {
		return nil, err
	}
	var hasCoupon bool
	if tmp.Data.HaveCoupon == "1" {
		hasCoupon = true
	}
	return &md.ConvertedUrls{
		ItemId:         itemId,
		URL:            tmp.Data.URL,
		ShortenURL:     tmp.Data.URL,
		NoOpenAppURL:   tmp.Data.URL,
		AppURL:         tmp.Data.URL,
		HasCoupon:      hasCoupon,
		CommissionRate: tmp.Data.MaxCommissionRate,
	}, nil
}
