package zhimeng

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/md"
	"encoding/json"
	"errors"
)

//会员id
func TaobaoPublisherRelationInfoList(appkey, appsecret, tbSid, p, tbAppKey string) (*[]md.PublisherInfo, error) {
	args := map[string]interface{}{
		"appkey":     appkey,
		"secret_key": appsecret,
		"session":    tbSid,
		"p":          p,
		"tb_app_key": tbAppKey,
	}
	resp, err := Send("agent_tb", "publisher_info_relation_list", args)
	if err != nil {
		return nil, err
	}
	var tmp struct {
		Data []struct {
			RelationId string `json:"relation_id"`
			SpecialId  string `json:"special_id"`
			ExternalId string `json:"external_id"`
			Rtag       string `json:"rtag"`
		} `json:"data"`
	}
	if err = json.Unmarshal(resp, &tmp); err != nil {
		return nil, err
	}
	if len(tmp.Data) == 0 {
		return nil, errors.New("没有商品")
	}

	var (
		res []md.PublisherInfo
	)
	for _, v := range tmp.Data {

		res = append(res, md.PublisherInfo{
			RelationId: v.RelationId,
			SpecialId:  v.SpecialId,
			ExternalId: v.ExternalId,
			Rtag:       v.Rtag,
		})
	}
	return &res, nil
}
