package zhimeng

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/db/model"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/md"
	zhios_third_party_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/utils"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/wph"
	"encoding/json"
	"errors"
	"github.com/syyongx/php2go"
	"github.com/tidwall/gjson"
	"time"
)

func CommWph(auth *model.SysUnionSet) map[string]string {
	serviceParam := map[string]string{
		"token":  "",
		"uuid":   "353543142",
		"key":    "8f8c427e",
		"secret": "DB9C5A92480618101A15835DD9E8AF69",
	}
	if auth != nil {
		serviceParam["token"] = gjson.Get(auth.KeyData, "accessToken").String()
	}
	return serviceParam
}

func OwnWphConvertUrl(auth *model.SysUnionSet, itemId, pid, couponPrice, adCode, openId, realCall string) (*md.ConvertedUrls, error) {
	urlGenByGoodsIdRequest := map[string]string{
		"realCall": "false",
		"openId":   openId,
		"adCode":   adCode,
	}
	if realCall == "1" {
		urlGenByGoodsIdRequest["realCall"] = "true"
	}
	serviceParam := CommWph(auth)
	paramData := map[string]interface{}{
		"goodsIdList":            []string{itemId},
		"requestId":              serviceParam["uuid"] + zhios_third_party_utils.Int64ToStr(time.Now().Unix()) + zhios_third_party_utils.IntToStr(php2go.Rand(1000, 9999)),
		"urlGenByGoodsIdRequest": urlGenByGoodsIdRequest,
		"chanTag":                pid,
	}
	param := zhios_third_party_utils.SerializeStr(paramData)
	url := wph.GetUrl(serviceParam, param)
	if url.Url == "" {
		return nil, errors.New("转链失败")
	}
	return &md.ConvertedUrls{
		ItemId:         itemId,
		URL:            url.Url,
		ShortenURL:     url.Url,
		NoOpenAppURL:   url.Url,
		AppURL:         url.DeeplinkUrl,
		HasCoupon:      false,
		CommissionRate: couponPrice,
		WeChatMiniURL:  url.VipWxUrl,
	}, nil
}

// todo
func VipConvertUrl(ak, sk, itemId, pid, couponPrice, adCode, openId, realCall string) (*md.ConvertedUrls, error) {
	args := map[string]interface{}{
		"appkey":     ak,
		"secret_key": sk,
		"gid":        itemId,
		"pid":        pid,
		"adCode":     adCode,
		"openId":     openId,
		"realCall":   realCall,
	}
	resp, err := Send("wph_new", "url", args)
	if err != nil {
		return nil, err
	}
	var tmp struct {
		Data struct {
			URL      string `json:"url"`
			DeepUrl  string `json:"deep_url"`
			VipWxUrl string `json:"vipWxUrl"`
		} `json:"data"`
	}
	if err = json.Unmarshal(resp, &tmp); err != nil {
		return nil, err
	}
	return &md.ConvertedUrls{
		ItemId:         itemId,
		URL:            tmp.Data.URL,
		ShortenURL:     tmp.Data.URL,
		NoOpenAppURL:   tmp.Data.URL,
		AppURL:         tmp.Data.DeepUrl,
		HasCoupon:      false,
		CommissionRate: couponPrice,
	}, nil
}
