package zhimeng

import (
	zhios_third_party_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/utils"
	"encoding/json"
	"errors"
)

// 搜索提示关键字
func SearchTips(s string) ([]string, error) {
	res, err := Send("tb_keyword", "index", map[string]interface{}{"keyword": s})
	if err != nil {
		return nil, err
	}
	tmp := struct {
		Success int      `json:"success,omitempty"`
		Msg     string   `json:"msg,omitempty"`
		Data    []string `json:"data,omitempty"`
	}{}
	err = json.Unmarshal(res, &tmp)
	if err != nil {
		return nil, err
	}
	if tmp.Success != StatusSuc {
		return nil, errors.New(tmp.Msg)
	}
	return tmp.Data, nil
}

// 解析淘口令, 成功返回产品goods_ID,失败返回空字符串
func WordParse(ak, sk, pid, s, sid, tbAppKey string) struct {
	Gid string `json:"gid"`
} {
	resp, err := Send("agent_tb", "tkl_gid", map[string]interface{}{
		"appkey":     ak,
		"secret_key": sk,
		"session":    sid,
		"keyword":    s,
		"pid":        pid,
		"tb_app_key": tbAppKey,
	})
	if err != nil {
		return struct {
			Gid string `json:"gid"`
		}{}
	}
	var tmp struct {
		Data struct {
			Gid string `json:"gid"`
		} `json:"data"`
	}
	zhios_third_party_utils.Unserialize(resp, &tmp)
	return tmp.Data
}
